
%{
#include "extern.h"
#include "head.h"

int se_interfaces_within_interfaces = 0;  /* hack to fix interf within interf */
%}


%start Program

%union {int integer; Node *node;};

%type<integer> '$'
%type<integer> '%'
%type<integer> '('
%type<integer> ')'
%type<integer> '*'
%type<integer> '+'
%type<integer> ','
%type<integer> '-'
%type<integer> '.'
%type<integer> '/'
%type<integer> ':'
%type<integer> '='
%type<integer> '?'
%token<integer> error                      258
%token<integer> ALLOCATABLE                259
%token<integer> ALLOCATE                   260
%token<integer> AND_OP                     261
%token<integer> ASSIGN                     262
%token<integer> BACKSPACE                  263
%token<integer> BINARY_CONSTANT            264
%token<integer> BLOCK_DATA                 265
%token<integer> CALL                       266
%token<integer> CASE                       267
%token<integer> CHAR_SELECTOR_COMMA        268
%token<integer> CHARACTER                  269
%token<node> CHARACTER_CONSTANT         270
%token<integer> CLOSE                      271
%token<integer> COMMON                     272
%token<integer> COMPLEX                    273
%token<integer> CONCAT_OP                  274
%token<integer> CONTAINS                   275
%token<integer> CONTINUE                   276
%token<integer> CYCLE                      277
%token<integer> DATA                       278
%token<integer> DOUBLE_COMPLEX             279
%token<integer> DEALLOCATE                 280
%token<integer> DEFINED_UNARY_OP           281
%token<integer> DIMENSION                  282
%token<integer> DO                         283
%token<integer> DOUBLE_PRECISION           284
%token<integer> ELSE                       285
%token<integer> ELSE_IF                    286
%token<integer> ELSE_WHERE                 287
%token<integer> END                        288
%token<integer> END_BLOCK_DATA             289
%token<integer> END_DO                     290
%token<integer> END_FILE                   291
%token<integer> END_FUNCTION               292
%token<integer> END_IF                     293
%token<integer> END_INTERFACE              294
%token<integer> END_MODULE                 295
%token<integer> END_PROGRAM                296
%token<integer> END_SELECT                 297
%token<integer> END_SUBROUTINE             298
%token<integer> END_TYPE                   299
%token<integer> END_WHERE                  300
%token<integer> ENTRY                      301
%token<integer> EOS                        302
%token<integer> EQUIVALENCE                303
%token<integer> EQUIV_OP_F                 304
%token<integer> EQUIV_OP_T                 305
%token<integer> EXIT                       306
%token<integer> EXTERNAL                   307
%token<node> FORMAT                     308
%token<integer> FUNCTION                   309
%token<integer> GO_TO                      310
%token<integer> HEX_CONSTANT               311
%token<integer> IF                         312
%token<integer> IMPLICIT                   313
%token<integer> INCLUDE                    314
%token<integer> INQUIRE                    315
%token<integer> INTEGER                    316
%token<node> INTEGER_CONSTANT           317
%token<integer> INTENT                     318
%token<integer> INTERFACE                  319
%token<integer> INTRINSIC                  320
%token<integer> LDAC                       321
%token<integer> LOGICAL                    322
%token<node> LOGICAL_CONSTANT           323
%token<integer> LPEQI                      324
%token<integer> LPIMP                      325
%token<integer> MODULE                     326
%token<node> NAME                       327
%token<integer> NAMELIST                   328
%token<integer> NOT_OP                     329
%token<integer> NULLIFY                    330
%token<integer> OCTAL_CONSTANT             331
%token<integer> OPEN                       332
%token<integer> OPTIONAL                   333
%token<integer> OR_OP                      334
%token<integer> PARAMETER                  335
%token<integer> PAUSE                      336
%token<integer> POINTER                    337
%token<integer> POINT_OP                   338
%token<integer> POINT_TO                   339
%token<integer> POWER_OP                   340
%token<integer> PRINT                      341
%token<integer> PRIVATE                    342
%token<integer> KPROGRAM                   343
%token<integer> PUBLIC                     344
%token<integer> RDAC                       345
%token<integer> READ                       346
%token<integer> REAL                       347
%token<node> REAL_CONSTANT              348
%token<integer> RECURSIVE                  349
%token<integer> REL_OP_EQ                  350
%token<integer> REL_OP_GE                  351
%token<integer> REL_OP_GT                  352
%token<integer> REL_OP_LE                  353
%token<integer> REL_OP_LT                  354
%token<integer> REL_OP_NE                  355
%token<integer> RETURN                     356
%token<integer> REWIND                     357
%token<integer> SAVE                       358
%token<integer> SELECT                     359
%token<integer> SEQUENCE                   360
%token<integer> STOP                       361
%token<integer> SUBROUTINE                 362
%token<integer> KTARGET                    363
%token<integer> TO                         364
%token<integer> TYPE                       365
%token<integer> USE                        366
%token<integer> WHERE                      367
%token<integer> WRITE                      368
%token<integer> XOR_OP                     369
%token<integer> ARRAY                      370
%token<integer> FORALL                     371
%token<integer> DIRBLOCK                   372
%token<integer> DIRMBLOCK                  373
%token<integer> DIRCYCLIC                  374
%token<integer> DIRDECOMPOSE               375
%token<integer> DIRDISTRIBUTE              376
%token<integer> DIRALIGN                   377
%token<integer> DIRWITH                    378
%token<integer> DIRINDEPENDENT             379
%token<integer> DIRNEW                     380
%token<integer> DIRPURE                    381
%token<integer> SFORALL                    382
%token<integer> SENDFORALL                 383
%token<integer> MFORALL                    384
%token<integer> ENDFORALL                  385
%token<integer> EXDIRCONSTRUCT             386
%token<integer> EXDIRLINK                  387
%token<integer> EXDIRLOAD                  388
%token<integer> EXDIRGEOMETRY              389
%token<integer> EXDIRPARTITION             390
%token<integer> EXDIRSET                   391
%token<integer> EXDIRBY                    392
%token<integer> EXDIRUSING                 393
%token<integer> EXDIRREDISTRIBUTE          394
%token<integer> DIRRANGE                   395
%token<integer> DIRPROCESSORS              396
%token<integer> DIRNUMBER_OF_PROCS         397
%token<integer> DIRSCALARPROC              398
%token<integer> SCHEDTYPE                  399
%token<integer> DIRFVPROC                  400
%token<integer> DIRFDECOMP                 401
%token<integer> DIRFEMBED                  402
%token<integer> DIRFDISTRIBUTE             403
%token<integer> DIRFALIGN                  404
%token<integer> DIRISDAD                   405
%token<integer> DIRISDECOMP                406
%token<integer> DUMTOK                     407
%token<integer> OP                         408
%token<node> CODE                       409
%token<node> KEY_NAME                   410
%token<integer> IGNORE_STMT                411

%type<node> Program                  
%type<node> Statement                
%type<node> DerivedTypeDef           
%type<node> Stmt                     
%type<node> ImplicitStmt             
%type<node> ImplicitNoneStmt         
%type<node> FormatStmt               
%type<node> EntryStmt                
%type<node> TypeDeclarationStmt      
%type<node> ParameterStmt            
%type<node> DataStmt                 
%type<node> CommonStmt               
%type<node> DimensionStmt            
%type<node> EquivalenceStmt          
%type<node> ExternalStmt             
%type<node> AssignementStmt          
%type<node> CallStmt                 
%type<node> CloseStmt                
%type<node> ComputedGotoStmt         
%type<node> ContinueStmt             
%type<node> EndFileStmt              
%type<node> BackspaceStmt            
%type<node> InquireStmt              
%type<node> GotoStmt                 
%type<node> IfStmt                   
%type<node> IfThenStmt               
%type<node> ElseIfStmt               
%type<node> ElseStmt                 
%type<node> EndIfStmt                
%type<node> DoStmt                   
%type<node> EndDoStmt                
%type<node> OpenStmt                 
%type<node> PrintStmt                
%type<node> ReadStmt                 
%type<node> ReturnStmt               
%type<node> RewindStmt               
%type<node> StopStmt                 
%type<node> WriteStmt                
%type<node> ArithmeticIfStmt         
%type<node> AssignStmt               
%type<node> AssignedGotoStmt         
%type<node> PauseStmt                
%type<node> EndStmt                  
%type<node> ProgramStmt              
%type<node> SubroutineStmt           
%type<node> FunctionStmt             
%type<node> IntrinsicStmt            
%type<node> IntentStmt               
%type<node> OptionalStmt             
%type<node> AccessStmt               
%type<node> SaveStmt                 
%type<node> AllocatableStmt          
%type<node> PointerStmt              
%type<node> TargetStmt               
%type<node> NamelistStmt             
%type<node> AllocateStmt             
%type<node> NullifyStmt              
%type<node> DeallocateStmt           
%type<node> PointerAssignementStmt   
%type<node> WhereStmt                
%type<node> WhereConstructStmt       
%type<node> ElsewhereStmt            
%type<node> EndWhereStmt             
%type<node> SelectCaseStmt           
%type<node> CaseStmt                 
%type<node> EndSelectStmt            
%type<node> ExitStmt                 
%type<node> CycleStmt                
%type<node> EndProgramStmt           
%type<node> ModuleStmt               
%type<node> EndModuleStmt            
%type<node> UseStmt                  
%type<node> BlockDataStmt            
%type<node> EndBlockDataStmt         
%type<node> InterfaceStmt            
%type<node> EndInterfaceStmt         
%type<node> ModuleProcedureStmt      
%type<node> EndFunctionStmt          
%type<node> EndSubroutineStmt        
%type<node> ContainsStmt             
%type<node> ForallStmt               
%type<node> IncludeStmt              
%type<node> DirectiveStmt            
%type<node> ForallConstructStmt      
%type<node> EndForallStmt            
%type<node> ExDirectiveStmt          
%type<node> BsDirectiveStmt          
%type<node> SForallConstructStmt     
%type<node> SEndForallStmt           
%type<node> NiceStmt                 
%type<node> IndependentStmt          
%type<node> PureStmt                 
%type<node> ForallTripletSpecList    
%type<node> OptScalarMaskExpr        
%type<node> DistSpec                 
%type<node> Size                     
%type<node> LinkInfo                 
%type<node> GeoInfo                  
%type<node> LoadInfo                 
%type<node> PartCall                 
%type<node> DistributeSpec           
%type<node> GeoArray                 
%type<node> AlignSpec                
%type<node> Expr                     
%type<node> DecomposeList            
%type<node> DistributeList           
%type<node> AlignStuff               
%type<node> OptCC                    
%type<node> ProcsDeclList            
%type<node> DecomposeSpec            
%type<node> SizeList                 
%type<node> DistList                 
%type<node> SubscriptList            
%type<node> AligneeList              
%type<node> NameList                 
%type<node> LiteralConstant          
%type<node> ComplexLiteralConstant   
%type<node> BozLiteralConstant       
%type<node> IntrinsicOp              
%type<node> MultOp                   
%type<node> AddOp                    
%type<node> RelOp                    
%type<node> EquivOp                  
%type<node> DefinedOperator          
%type<node> DerivedTypeStmt          
%type<node> OptPrivateSequenceStmtList
%type<node> ComponentDefStmtList     
%type<node> EndTypeStmt              
%type<node> PrivateSequenceStmtList  
%type<node> PrivateSequenceStmt      
%type<node> ComponentDefStmt         
%type<node> AccessSpec               
%type<node> TypeSpec                 
%type<node> ComponentAttrSpecList    
%type<node> ComponentDeclList        
%type<node> ComponentDecl            
%type<node> ComponentAttrSpec        
%type<node> CharLength               
%type<node> ArrayConstructor         
%type<node> AcValueList              
%type<node> ImpliedValueList         
%type<node> ImpliedValue             
%type<node> ImpliedDo                
%type<node> Stride                   
%type<node> ImpliedDoControl         
%type<node> OptComma                 
%type<node> AttrSpecList             
%type<node> EntityDecl1List          
%type<node> EntityDeclList           
%type<node> EntityDecl               
%type<node> EntityDecl1              
%type<node> AttrSpec                 
%type<node> OptKindSelector          
%type<node> CharSelector             
%type<node> OptCharLength            
%type<node> OptInitializationExpr    
%type<node> opt7                     
%type<node> KindSelector             
%type<node> TypeParamValue           
%type<node> SavedEntityList          
%type<node> SavedEntity              
%type<node> EntityAllocatableList    
%type<node> EntityAllocatable        
%type<node> EntityTargetList         
%type<node> EntityTarget             
%type<node> DataStmtSetList          
%type<node> DataStmtSet              
%type<node> DataStmtObjectList       
%type<node> DataStmtValueList        
%type<node> DataStmtObject           
%type<node> DataStmtValue            
%type<node> Variable                 
%type<node> DataImpliedDo            
%type<node> DataStmtRepeat           
%type<node> DataStmtConstant         
%type<node> ArraySection             
%type<node> NamedConstantDefList     
%type<node> NamedConstantDef         
%type<node> ImplicitSpecList         
%type<node> ImplicitSpec             
%type<node> LetterSpecList           
%type<node> LetterSpec               
%type<node> Letter                   
%type<node> EquivalenceSetList       
%type<node> EquivalenceSet           
%type<node> EquivalenceObjectList    
%type<node> EquivalenceObject        
%type<node> CommonStmt1              
%type<node> CommonBlock              
%type<node> StructureComponent       
%type<node> ParentStructure          
%type<node> Org_SubscriptList        
%type<node> Subscript                
%type<node> Label                    
%type<node> AllocationList           
%type<node> Allocation               
%type<node> AllocateObject           
%type<node> AllocateObjectList       
%type<node> Primary                  
%type<node> Level1Expr               
%type<node> MultOperand              
%type<node> AddOperand               
%type<node> Level2Expr               
%type<node> Level3Expr               
%type<node> Level4Expr               
%type<node> AndOperand               
%type<node> OrOperand                
%type<node> EquivOperand             
%type<node> Level5Expr               
%type<node> Target                   
%type<node> CaseSelector             
%type<node> OptLabel                 
%type<node> LoopControl              
%type<node> LabelList                
%type<node> StopCode                 
%type<node> ForallTripletSpec        
%type<node> IoSpecList               
%type<node> IoSpec                   
%type<node> FormatSpec               
%type<node> InputItemList            
%type<node> FormatExpr               
%type<node> OutputItemList           
%type<node> RenameList               
%type<node> OnlyList                 
%type<node> Rename                   
%type<node> Only                     
%type<node> GenericSpec              
%type<node> opt31                    
%type<node> OptNameList              
%type<node> opt33                    
%type<node> Prefix                   
%type<node> OptRecursive             
%type<node> OptDummyArgList          
%type<node> DummyArgList             
%type<node> DummyArg                 

%%

Program
	:
	{
		$$ = (Node*) 0;
	}
	| Program Statement
	{
		tree = $$ = make (PROGRAM);
		$$->Program.Program = $1;
		$$->Program.Statement = $2;
	{
		int i;
		Node *orig_stmt;

		if (se_interfaces_within_interfaces) {
			if ($2->Statement.Stmt != NN) {
				if ($2->Statement.Stmt->com.type == END_INTERFACE)
					se_interfaces_within_interfaces--;

/*!!! Next is a partial fix, it will not work if type is not decl
      in the FunStmt. */

				if ($2->Statement.Stmt->com.type == FUNCTION_STMT) {
					if (se_EtypeSpec == EN)
						se_EtypeSpec
						= implicit_get ($2->Statement.Stmt->FunctionStmt.Name->com.str);

					install_loc (
					  $2->Statement.Stmt->FunctionStmt.Name->com.str
					, TAB_TYP_ETYPE, se_EtypeSpec);
				}
			}

			goto skip_rest;
		}
		if (flag_pp)
			tree_pp ($2);

		orig_stmt = $2->Statement.Stmt;
		$2 = $$->Program.Statement = parse_pass ($2);
		if (se_is_statement_function_def)
			$2->Statement.fun = order ($2->Statement.Stmt);
		else if (orig_stmt != NN)
			$2->Statement.fun = order (orig_stmt);
		if ($2->Statement.Stmt != NN && $2->Statement.Stmt->def.type != IGNORE_STMT)
			if (!se_in_interface)
				block_add_sta ($2);
		clear_se ();
		if ($2->Statement.Stmt != NN) {
			switch ($2->Statement.Stmt->com.type) {

			case END_STMT:
			case END_FUNCTION_STMT:
			case END_BLOCK_DATA_STMT:
			case END_SUBROUTINE_STMT:
			case END_MODULE_STMT:
			case END_PROGRAM_STMT:
				if (flag_pp) {
					printf ("\n------- after TRANS ---------\n\n");
					tree_pp (program_unit);
					printf ("\n-----------------------------\n\n");
				}
				if (!se_in_interface
				&& (flag_ignore_fatal || error_level < ERR_NOTIMPLEM)
				&& (se_unit_stmt == NN || se_unit_stmt->com.type != MODULE_STMT)
				)  comm_ProgramUnit (program_unit );
             			current_pass = PASS_WRITE;
				proc_end_before_write ();
				if (!se_in_interface
				&& (flag_ignore_fatal || error_level < ERR_NOTIMPLEM)
				&& (se_unit_stmt == NN || se_unit_stmt->com.type != MODULE_STMT)
				) {
					write_ProgramUnit (program_unit);
#ifdef KO
					if (flag_ko)
						ko_add (program_unit);
#endif
				}

#ifdef CHECK
				if (flag_tableshow)
					if (num_yywrap)
						table_show1 ();
#endif

				proc_end_after_write ();
				current_pass = PASS_PARSE;
				$$ = NN;
				break;
			}
		}

		skip_rest:;
	}
	}
	| Program DerivedTypeDef
	{
		tree = $$ = make (PROGRAM);
		$$->Program.Program = $1;
		$$->Program.DerivedTypeDef = $2;
	{
		f90ni_uddtao ();
	}
	}
	;

Statement
	: INTEGER_CONSTANT Stmt EOS
	{
		$$ = make (STATEMENT);
		$$->Statement.IntegerConstant = $1;
		$$->Statement.Stmt = $2;
		$$->Statement.Eos = &Eos;
	{
		int type = $2->com.type;

		if (type == INCLUDE_STMT) {
			fatal ("labels not allowed in INCLUDE statements");
			$$->Statement.Stmt = NN;
			$$->Statement.Error = &Error;
		}

		if (type == FORALL_STMT)
			$2->ForallStmt.statement = $$;

		$$->Statement.line = zzlineno;
		$$->Statement.file = input_filename;

		if (type == FORMAT_STMT) {
			checkx_FormatStmt ($$);
			label_install_format ($1);
		}
		else {
			label_install_def ($1);
		}
	}
	}
	| Stmt EOS
	{
		$$ = make (STATEMENT);
		$$->Statement.Stmt = $1;
		$$->Statement.Eos = &Eos;
	{
		int type = $1->com.type;
 
		if (type == FORMAT_STMT)
			fatal ("no LABEL in FORMAT statement");

		if (type == INCLUDE_STMT)
			include_add ($1->IncludeStmt.CharacterConstant->com.str);

		$$->Statement.line = zzlineno;
		$$->Statement.file = input_filename;

		if ($1->com.type == FORALL_STMT)
			$1->ForallStmt.statement = $$;
	}
	}
	| EOS
	{
		$$ = make (STATEMENT);
		$$->Statement.Eos = &Eos;
	{
		$$->Statement.line = zzlineno;
		$$->Statement.file = input_filename;
	}
	}
	| error EOS
	{
		$$ = make (STATEMENT);
		$$->Statement.Error = &Error;
		$$->Statement.Eos = &Eos;
	{
		$$->Statement.line = zzlineno - 1;
		yyerrok;
	}
	}
	;

DerivedTypeDef
	: DerivedTypeStmt EOS OptPrivateSequenceStmtList ComponentDefStmtList EndTypeStmt EOS
	{$$ = make (DERIVED_TYPE_DEF);}

	;

Stmt
	: ImplicitStmt
	| ImplicitNoneStmt
	| FormatStmt
	| EntryStmt
	| TypeDeclarationStmt
	| ParameterStmt
	| DataStmt
	| CommonStmt
	| DimensionStmt
	| EquivalenceStmt
	| ExternalStmt
	| AssignementStmt
	| CallStmt
	| CloseStmt
	| ComputedGotoStmt
	| ContinueStmt
	| EndFileStmt
	| BackspaceStmt
	| InquireStmt
	| GotoStmt
	| IfStmt
	| IfThenStmt
	| ElseIfStmt
	| ElseStmt
	| EndIfStmt
	| DoStmt
	| EndDoStmt
	| OpenStmt
	| PrintStmt
	| ReadStmt
	| ReturnStmt
	| RewindStmt
	| StopStmt
	| WriteStmt
	| ArithmeticIfStmt
	| AssignStmt
	| AssignedGotoStmt
	| PauseStmt
	| EndStmt
	| ProgramStmt
	| SubroutineStmt
	| FunctionStmt
	| IntrinsicStmt
	| IntentStmt
	| OptionalStmt
	| AccessStmt
	| SaveStmt
	| AllocatableStmt	{
		f90ni_pointers ();
	}

	| PointerStmt	{
		f90ni_pointers ();
	}

	| TargetStmt	{
		f90ni_pointers ();
	}

	| NamelistStmt
	| AllocateStmt	{
		f90ni_pointers ();
	}

	| NullifyStmt	{
		f90ni_pointers ();
	}

	| DeallocateStmt	{
		f90ni_pointers ();
	}

	| PointerAssignementStmt	{
		f90ni_pointers ();
	}

	| WhereStmt
	| WhereConstructStmt
	| ElsewhereStmt
	| EndWhereStmt
	| SelectCaseStmt
	| CaseStmt
	| EndSelectStmt
	| ExitStmt
	| CycleStmt
	| EndProgramStmt
	| ModuleStmt
	| EndModuleStmt
	| UseStmt
	| BlockDataStmt
	| EndBlockDataStmt
	| InterfaceStmt
	| EndInterfaceStmt
	| ModuleProcedureStmt
	| EndFunctionStmt
	| EndSubroutineStmt
	| ContainsStmt	{
		f90ni_internal_procedures ();
	}

	| ForallStmt
	| IncludeStmt
	| DirectiveStmt
	| ForallConstructStmt
	| EndForallStmt
	| ExDirectiveStmt
	| BsDirectiveStmt
	| SForallConstructStmt
	| SEndForallStmt
	| NiceStmt
	| IndependentStmt
	| PureStmt
	;

ImplicitStmt
	: IMPLICIT ImplicitSpecList
	{
		$$ = make (IMPLICIT_STMT);
		$$->ImplicitStmt.Implicit = &Implicit;
		$$->ImplicitStmt.ImplicitSpecList = $2;
	}
	;

ImplicitNoneStmt
	: IMPLICIT NAME
	{
		key_check ($2, "NONE");

		implicit_set_none ();
		$$ = &IgnoreStmt;
	}

	;

FormatStmt
	: FORMAT
	{
		$$ = make (FORMAT_STMT);
		$$->FormatStmt.Format = $1;
	}
	;

EntryStmt
	: ENTRY NAME '(' DummyArgList ')'
	{
		$$ = make (ENTRY_STMT);
		$$->EntryStmt.Entry = &Entry;
		$$->EntryStmt.Name = $2;
		$$->EntryStmt.Lp = &Lp;
		$$->EntryStmt.DummyArgList = $4;
		$$->EntryStmt.Rp = &Rp;
	}
	| ENTRY NAME '(' ')'
	{
		$$ = make (ENTRY_STMT);
		$$->EntryStmt.Entry = &Entry;
		$$->EntryStmt.Name = $2;
		$$->EntryStmt.Lp = &Lp;
		$$->EntryStmt.Rp = &Rp;
	}
	| ENTRY NAME
	{
		$$ = make (ENTRY_STMT);
		$$->EntryStmt.Entry = &Entry;
		$$->EntryStmt.Name = $2;
	}
	;

TypeDeclarationStmt
	: TypeSpec ',' AttrSpecList ':' ':' EntityDecl1List
	{
		$$ = make (TYPE_DECLARATION_STMT);
		$$->TypeDeclarationStmt.TypeSpec = $1;
		$$->TypeDeclarationStmt.Comma = &Comma;
		$$->TypeDeclarationStmt.AttrSpecList = $3;
		$$->TypeDeclarationStmt.Colon = &Colon;
		$$->TypeDeclarationStmt.Colon1 = &Colon;
		$$->TypeDeclarationStmt.EntityDecl1List = $6;
	}
	| TypeSpec ':' ':' EntityDecl1List
	{
		$$ = make (TYPE_DECLARATION_STMT);
		$$->TypeDeclarationStmt.TypeSpec = $1;
		$$->TypeDeclarationStmt.Colon = &Colon;
		$$->TypeDeclarationStmt.Colon1 = &Colon;
		$$->TypeDeclarationStmt.EntityDecl1List = $4;
	}
	| TypeSpec EntityDecl1List
	{
		$$ = make (TYPE_DECLARATION_STMT);
		$$->TypeDeclarationStmt.TypeSpec = $1;
		$$->TypeDeclarationStmt.EntityDecl1List = $2;
	}
	;

ParameterStmt
	: PARAMETER '(' NamedConstantDefList ')'
	{
		$$ = make (PARAMETER_STMT);
		$$->ParameterStmt.Parameter = &Parameter;
		$$->ParameterStmt.Lp = &Lp;
		$$->ParameterStmt.NamedConstantDefList = $3;
		$$->ParameterStmt.Rp = &Rp;
	}
	| PARAMETER LPEQI NamedConstantDefList ')'
	{
		$$ = make (PARAMETER_STMT);
		$$->ParameterStmt.Parameter = &Parameter;
		$$->ParameterStmt.Lpeqi = &Lpeqi;
		$$->ParameterStmt.NamedConstantDefList = $3;
		$$->ParameterStmt.Rp = &Rp;
	{
		$$->ParameterStmt.Lp = &Lp;
		$$->ParameterStmt.Lpeqi = NN;
	}
	}
	;

DataStmt
	: DATA DataStmtSetList
	{
		$$ = make (DATA_STMT);
		$$->DataStmt.Data = &Data;
		$$->DataStmt.DataStmtSetList = $2;
	}
	;

CommonStmt
	: CommonStmt1
	{
		$$ = make (COMMON_STMT);
		$$->CommonStmt.CommonStmt1 = $1;
	}
	| CommonStmt ',' CommonBlock EntityDecl
	{
		$$ = make (COMMON_STMT);
		$$->CommonStmt.CommonStmt = $1;
		$$->CommonStmt.Comma = &Comma;
		$$->CommonStmt.CommonBlock = $3;
		$$->CommonStmt.EntityDecl = $4;
	}
	| CommonStmt CommonBlock EntityDecl
	{
		$$ = make (COMMON_STMT);
		$$->CommonStmt.CommonStmt = $1;
		$$->CommonStmt.CommonBlock = $2;
		$$->CommonStmt.EntityDecl = $3;
	}
	| CommonStmt ',' EntityDecl
	{
		$$ = make (COMMON_STMT);
		$$->CommonStmt.CommonStmt = $1;
		$$->CommonStmt.Comma = &Comma;
		$$->CommonStmt.EntityDecl = $3;
	}
	;

DimensionStmt
	: DIMENSION
	{
		se_DimensionStmt_in = 1;
	}
	 EntityDeclList
	{
		$$ = make (DIMENSION_STMT);
		$$->DimensionStmt.Dimension = &Dimension;
		$$->DimensionStmt.EntityDeclList = $3;
	}
	;

EquivalenceStmt
	: EQUIVALENCE EquivalenceSetList
	{
		$$ = make (EQUIVALENCE_STMT);
		$$->EquivalenceStmt.Equivalence = &Equivalence;
		$$->EquivalenceStmt.EquivalenceSetList = $2;
	}
	;

ExternalStmt
	: EXTERNAL NameList
	{
		$$ = make (EXTERNAL_STMT);
		$$->ExternalStmt.External = &External;
		$$->ExternalStmt.NameList = $2;
	}
	;

AssignementStmt
	: Variable '=' Expr
	{
		$$ = make (ASSIGNEMENT_STMT);
		$$->AssignementStmt.Variable = $1;
		$$->AssignementStmt.Eq = &Eq;
		$$->AssignementStmt.Expr = $3;
	}
	;

CallStmt
	: CALL NAME '(' SubscriptList ')'
	{
		$$ = make (CALL_STMT);
		$$->CallStmt.Call = &Call;
		$$->CallStmt.Name = $2;
		$$->CallStmt.Lp = &Lp;
		$$->CallStmt.SubscriptList = $4;
		$$->CallStmt.Rp = &Rp;
	{
		$4 = $$->CallStmt.SubscriptList = list_invert ($4);
	}
	}
	| CALL NAME LPEQI SubscriptList ')'
	{
		$$ = make (CALL_STMT);
		$$->CallStmt.Call = &Call;
		$$->CallStmt.Name = $2;
		$$->CallStmt.Lpeqi = &Lpeqi;
		$$->CallStmt.SubscriptList = $4;
		$$->CallStmt.Rp = &Rp;
	{
		$4 = $$->CallStmt.SubscriptList = list_invert ($4);
		$$->CallStmt.Lp = &Lp;
		$$->CallStmt.Lpeqi = NN;
	}
	}
	| CALL NAME '(' ')'
	{
		$$ = make (CALL_STMT);
		$$->CallStmt.Call = &Call;
		$$->CallStmt.Name = $2;
		$$->CallStmt.Lp = &Lp;
		$$->CallStmt.Rp = &Rp;
	}
	| CALL NAME
	{
		$$ = make (CALL_STMT);
		$$->CallStmt.Call = &Call;
		$$->CallStmt.Name = $2;
	}
	;

CloseStmt
	: CLOSE '(' IoSpecList ')'
	{
		$$ = make (CLOSE_STMT);
		$$->CloseStmt.Close = &Close;
		$$->CloseStmt.Lp = &Lp;
		$$->CloseStmt.IoSpecList = $3;
		$$->CloseStmt.Rp = &Rp;
	}
	| CLOSE LPEQI IoSpecList ')'
	{
		$$ = make (CLOSE_STMT);
		$$->CloseStmt.Close = &Close;
		$$->CloseStmt.Lpeqi = &Lpeqi;
		$$->CloseStmt.IoSpecList = $3;
		$$->CloseStmt.Rp = &Rp;
	{
		$$->CloseStmt.Lp = &Lp;
		$$->CloseStmt.Lpeqi = NN;
	}
	}
	;

ComputedGotoStmt
	: GO_TO '(' LabelList ')' OptComma Expr
	{
		$$ = make (COMPUTED_GOTO_STMT);
		$$->ComputedGotoStmt.GoTo = &GoTo;
		$$->ComputedGotoStmt.Lp = &Lp;
		$$->ComputedGotoStmt.LabelList = $3;
		$$->ComputedGotoStmt.Rp = &Rp;
		$$->ComputedGotoStmt.OptComma = $5;
		$$->ComputedGotoStmt.Expr = $6;
	}
	;

ContinueStmt
	: CONTINUE
	{
		$$ = make (CONTINUE_STMT);
		$$->ContinueStmt.Continue = &Continue;
	}
	;

EndFileStmt
	: END_FILE Expr
	{
		$$ = make (END_FILE_STMT);
		$$->EndFileStmt.EndFile = &EndFile;
		$$->EndFileStmt.Expr = $2;
	}
	| END_FILE LPEQI IoSpecList ')'
	{
		$$ = make (END_FILE_STMT);
		$$->EndFileStmt.EndFile = &EndFile;
		$$->EndFileStmt.Lpeqi = &Lpeqi;
		$$->EndFileStmt.IoSpecList = $3;
		$$->EndFileStmt.Rp = &Rp;
	}
	;

BackspaceStmt
	: BACKSPACE Expr
	{
		$$ = make (BACKSPACE_STMT);
		$$->BackspaceStmt.Backspace = &Backspace;
		$$->BackspaceStmt.Expr = $2;
	}
	| BACKSPACE LPEQI IoSpecList ')'
	{
		$$ = make (BACKSPACE_STMT);
		$$->BackspaceStmt.Backspace = &Backspace;
		$$->BackspaceStmt.Lpeqi = &Lpeqi;
		$$->BackspaceStmt.IoSpecList = $3;
		$$->BackspaceStmt.Rp = &Rp;
	}
	;

InquireStmt
	: INQUIRE '(' IoSpecList ')'
	{
		$$ = make (INQUIRE_STMT);
		$$->InquireStmt.Inquire = &Inquire;
		$$->InquireStmt.Lp = &Lp;
		$$->InquireStmt.IoSpecList = $3;
		$$->InquireStmt.Rp = &Rp;
	}
	| INQUIRE LPEQI IoSpecList ')'
	{
		$$ = make (INQUIRE_STMT);
		$$->InquireStmt.Inquire = &Inquire;
		$$->InquireStmt.Lpeqi = &Lpeqi;
		$$->InquireStmt.IoSpecList = $3;
		$$->InquireStmt.Rp = &Rp;
	}
	;

GotoStmt
	: GO_TO Label
	{
		$$ = make (GOTO_STMT);
		$$->GotoStmt.GoTo = &GoTo;
		$$->GotoStmt.Label = $2;
	}
	;

IfStmt
	: IF '(' Expr ')' Stmt
	{
		$$ = make (IF_STMT);
		$$->IfStmt.If = &If;
		$$->IfStmt.Lp = &Lp;
		$$->IfStmt.Expr = $3;
		$$->IfStmt.Rp = &Rp;
		$$->IfStmt.Stmt = $5;
	}
	| IF LPEQI Expr ')' Stmt
	{
		$$ = make (IF_STMT);
		$$->IfStmt.If = &If;
		$$->IfStmt.Lpeqi = &Lpeqi;
		$$->IfStmt.Expr = $3;
		$$->IfStmt.Rp = &Rp;
		$$->IfStmt.Stmt = $5;
	{
		$$->IfStmt.Lpeqi = NN;
		$$->IfStmt.Lp = &Lp;
	}
	}
	;

IfThenStmt
	: IF '(' Expr ')' NAME
	{
		$$ = make (IF_THEN_STMT);
		$$->IfThenStmt.If = &If;
		$$->IfThenStmt.Lp = &Lp;
		$$->IfThenStmt.Expr = $3;
		$$->IfThenStmt.Rp = &Rp;
		$$->IfThenStmt.Name = $5;
	{
		key_check ($5, "THEN");
	}
	}
	| NAME ':' IF '(' Expr ')' NAME
	{
		$$ = make (IF_THEN_STMT);
		$$->IfThenStmt.Name = $1;
		$$->IfThenStmt.Colon = &Colon;
		$$->IfThenStmt.If = &If;
		$$->IfThenStmt.Lp = &Lp;
		$$->IfThenStmt.Expr = $5;
		$$->IfThenStmt.Rp = &Rp;
		$$->IfThenStmt.Name1 = $7;
	{
		key_check ($7, "THEN");
	}
	}
	| IF LPEQI Expr ')' NAME
	{
		$$ = make (IF_THEN_STMT);
		$$->IfThenStmt.If = &If;
		$$->IfThenStmt.Lpeqi = &Lpeqi;
		$$->IfThenStmt.Expr = $3;
		$$->IfThenStmt.Rp = &Rp;
		$$->IfThenStmt.Name = $5;
	{
		key_check ($5, "THEN");

		$$->IfThenStmt.Lpeqi = NN;
		$$->IfThenStmt.Lp = &Lp;
	}
	}
	| NAME ':' IF LPEQI Expr ')' NAME
	{
		$$ = make (IF_THEN_STMT);
		$$->IfThenStmt.Name = $1;
		$$->IfThenStmt.Colon = &Colon;
		$$->IfThenStmt.If = &If;
		$$->IfThenStmt.Lpeqi = &Lpeqi;
		$$->IfThenStmt.Expr = $5;
		$$->IfThenStmt.Rp = &Rp;
		$$->IfThenStmt.Name1 = $7;
	{
		key_check ($7, "THEN");

		$$->IfThenStmt.Lpeqi = NN;
		$$->IfThenStmt.Lp = &Lp;
	}
	}
	;

ElseIfStmt
	: ELSE_IF '(' Expr ')' NAME NAME
	{
		$$ = make (ELSE_IF_STMT);
		$$->ElseIfStmt.ElseIf = &ElseIf;
		$$->ElseIfStmt.Lp = &Lp;
		$$->ElseIfStmt.Expr = $3;
		$$->ElseIfStmt.Rp = &Rp;
		$$->ElseIfStmt.Name = $5;
		$$->ElseIfStmt.Name1 = $6;
	{
		key_check ($5, "THEN");
	}
	}
	| ELSE_IF '(' Expr ')' NAME
	{
		$$ = make (ELSE_IF_STMT);
		$$->ElseIfStmt.ElseIf = &ElseIf;
		$$->ElseIfStmt.Lp = &Lp;
		$$->ElseIfStmt.Expr = $3;
		$$->ElseIfStmt.Rp = &Rp;
		$$->ElseIfStmt.Name = $5;
	{
		char *name;

		if ((name = key_check ($5, "THEN")) != CN)
			$$->ElseIfStmt.Name1 = make_Name (name);
	}
	}
	| ELSE_IF LPEQI Expr ')' NAME NAME
	{
		$$ = make (ELSE_IF_STMT);
		$$->ElseIfStmt.ElseIf = &ElseIf;
		$$->ElseIfStmt.Lpeqi = &Lpeqi;
		$$->ElseIfStmt.Expr = $3;
		$$->ElseIfStmt.Rp = &Rp;
		$$->ElseIfStmt.Name = $5;
		$$->ElseIfStmt.Name1 = $6;
	{
		key_check ($5, "THEN");

		$$->ElseIfStmt.Lpeqi = NN;
		$$->ElseIfStmt.Lp = &Lp;
	}
	}
	| ELSE_IF LPEQI Expr ')' NAME
	{
		$$ = make (ELSE_IF_STMT);
		$$->ElseIfStmt.ElseIf = &ElseIf;
		$$->ElseIfStmt.Lpeqi = &Lpeqi;
		$$->ElseIfStmt.Expr = $3;
		$$->ElseIfStmt.Rp = &Rp;
		$$->ElseIfStmt.Name = $5;
	{
		char *name;

		if ((name = key_check ($5, "THEN")) != CN)
			$$->ElseIfStmt.Name1 = make_Name (name);

		$$->ElseIfStmt.Lpeqi = NN;
		$$->ElseIfStmt.Lp = &Lp;
	}
	}
	;

ElseStmt
	: ELSE NAME
	{
		$$ = make (ELSE_STMT);
		$$->ElseStmt.Else = &Else;
		$$->ElseStmt.Name = $2;
	}
	| ELSE
	{
		$$ = make (ELSE_STMT);
		$$->ElseStmt.Else = &Else;
	}
	;

EndIfStmt
	: END_IF NAME
	{
		$$ = make (END_IF_STMT);
		$$->EndIfStmt.EndIf = &EndIf;
		$$->EndIfStmt.Name = $2;
	}
	| END_IF
	{
		$$ = make (END_IF_STMT);
		$$->EndIfStmt.EndIf = &EndIf;
	}
	;

DoStmt
	: NAME ':' DO OptLabel LoopControl
	{
		$$ = make (DO_STMT);
		$$->DoStmt.Name = $1;
		$$->DoStmt.Colon = &Colon;
		$$->DoStmt.Do = &Do;
		$$->DoStmt.OptLabel = $4;
		$$->DoStmt.LoopControl = $5;
	{
    /* ##BEG## Kishore 10/7/93 */
    if(is_this_independent_loop() == TRUE) {
        $$->DoStmt.ind_loop_flag = TRUE;
    } else
        $$->DoStmt.ind_loop_flag = FALSE;
    /* ##END## Kishore 10/7/93 */
    }
	}
	| DO OptLabel LoopControl
	{
		$$ = make (DO_STMT);
		$$->DoStmt.Do = &Do;
		$$->DoStmt.OptLabel = $2;
		$$->DoStmt.LoopControl = $3;
	{
    /* ##BEG## Kishore 10/7/93 */
    if(is_this_independent_loop() == TRUE) {
        $$->DoStmt.ind_loop_flag = TRUE;
    } else
        $$->DoStmt.ind_loop_flag = FALSE;
    /* ##END## Kishore 10/7/93 */
    }
	}
	;

EndDoStmt
	: END_DO NAME
	{
		$$ = make (END_DO_STMT);
		$$->EndDoStmt.EndDo = &EndDo;
		$$->EndDoStmt.Name = $2;
	}
	| END_DO
	{
		$$ = make (END_DO_STMT);
		$$->EndDoStmt.EndDo = &EndDo;
	}
	;

OpenStmt
	: OPEN '(' IoSpecList ')'
	{
		$$ = make (OPEN_STMT);
		$$->OpenStmt.Open = &Open;
		$$->OpenStmt.Lp = &Lp;
		$$->OpenStmt.IoSpecList = $3;
		$$->OpenStmt.Rp = &Rp;
	}
	| OPEN LPEQI IoSpecList ')'
	{
		$$ = make (OPEN_STMT);
		$$->OpenStmt.Open = &Open;
		$$->OpenStmt.Lpeqi = &Lpeqi;
		$$->OpenStmt.IoSpecList = $3;
		$$->OpenStmt.Rp = &Rp;
	{
		$$->OpenStmt.Lp = &Lp;
		$$->OpenStmt.Lpeqi = NN;
	}
	}
	;

PrintStmt
	: PRINT FormatSpec
	{
		$$ = make (PRINT_STMT);
		$$->PrintStmt.Print = &Print;
		$$->PrintStmt.FormatSpec = $2;
	}
	| PRINT FormatSpec ',' OutputItemList
	{
		$$ = make (PRINT_STMT);
		$$->PrintStmt.Print = &Print;
		$$->PrintStmt.FormatSpec = $2;
		$$->PrintStmt.Comma = &Comma;
		$$->PrintStmt.OutputItemList = $4;
	}
	;

ReadStmt
	: READ FormatSpec
	{
		$$ = make (READ_STMT);
		$$->ReadStmt.Read = &Read;
		$$->ReadStmt.FormatSpec = $2;
	}
	| READ '(' IoSpecList ')'
	{
		$$ = make (READ_STMT);
		$$->ReadStmt.Read = &Read;
		$$->ReadStmt.Lp = &Lp;
		$$->ReadStmt.IoSpecList = $3;
		$$->ReadStmt.Rp = &Rp;
	}
	| READ LPEQI IoSpecList ')'
	{
		$$ = make (READ_STMT);
		$$->ReadStmt.Read = &Read;
		$$->ReadStmt.Lpeqi = &Lpeqi;
		$$->ReadStmt.IoSpecList = $3;
		$$->ReadStmt.Rp = &Rp;
	}
	| READ FormatSpec ',' InputItemList
	{
		$$ = make (READ_STMT);
		$$->ReadStmt.Read = &Read;
		$$->ReadStmt.FormatSpec = $2;
		$$->ReadStmt.Comma = &Comma;
		$$->ReadStmt.InputItemList = $4;
	}
	| READ '(' IoSpecList ')' InputItemList
	{
		$$ = make (READ_STMT);
		$$->ReadStmt.Read = &Read;
		$$->ReadStmt.Lp = &Lp;
		$$->ReadStmt.IoSpecList = $3;
		$$->ReadStmt.Rp = &Rp;
		$$->ReadStmt.InputItemList = $5;
	}
	| READ LPEQI IoSpecList ')' InputItemList
	{
		$$ = make (READ_STMT);
		$$->ReadStmt.Read = &Read;
		$$->ReadStmt.Lpeqi = &Lpeqi;
		$$->ReadStmt.IoSpecList = $3;
		$$->ReadStmt.Rp = &Rp;
		$$->ReadStmt.InputItemList = $5;
	}
	;

ReturnStmt
	: RETURN Expr
	{
		$$ = make (RETURN_STMT);
		$$->ReturnStmt.Return = &Return;
		$$->ReturnStmt.Expr = $2;
	}
	| RETURN
	{
		$$ = make (RETURN_STMT);
		$$->ReturnStmt.Return = &Return;
	}
	;

RewindStmt
	: REWIND Expr
	{
		$$ = make (REWIND_STMT);
		$$->RewindStmt.Rewind = &Rewind;
		$$->RewindStmt.Expr = $2;
	}
	| REWIND LPEQI IoSpecList ')'
	{
		$$ = make (REWIND_STMT);
		$$->RewindStmt.Rewind = &Rewind;
		$$->RewindStmt.Lpeqi = &Lpeqi;
		$$->RewindStmt.IoSpecList = $3;
		$$->RewindStmt.Rp = &Rp;
	}
	;

StopStmt
	: STOP StopCode
	{
		$$ = make (STOP_STMT);
		$$->StopStmt.Stop = &Stop;
		$$->StopStmt.StopCode = $2;
	}
	| STOP
	{
		$$ = make (STOP_STMT);
		$$->StopStmt.Stop = &Stop;
	}
	;

WriteStmt
	: WRITE '(' IoSpecList ')'
	{
		$$ = make (WRITE_STMT);
		$$->WriteStmt.Write = &Write;
		$$->WriteStmt.Lp = &Lp;
		$$->WriteStmt.IoSpecList = $3;
		$$->WriteStmt.Rp = &Rp;
	}
	| WRITE LPEQI IoSpecList ')'
	{
		$$ = make (WRITE_STMT);
		$$->WriteStmt.Write = &Write;
		$$->WriteStmt.Lpeqi = &Lpeqi;
		$$->WriteStmt.IoSpecList = $3;
		$$->WriteStmt.Rp = &Rp;
	}
	| WRITE '(' IoSpecList ')' OutputItemList
	{
		$$ = make (WRITE_STMT);
		$$->WriteStmt.Write = &Write;
		$$->WriteStmt.Lp = &Lp;
		$$->WriteStmt.IoSpecList = $3;
		$$->WriteStmt.Rp = &Rp;
		$$->WriteStmt.OutputItemList = $5;
	}
	| WRITE LPEQI IoSpecList ')' OutputItemList
	{
		$$ = make (WRITE_STMT);
		$$->WriteStmt.Write = &Write;
		$$->WriteStmt.Lpeqi = &Lpeqi;
		$$->WriteStmt.IoSpecList = $3;
		$$->WriteStmt.Rp = &Rp;
		$$->WriteStmt.OutputItemList = $5;
	}
	;

ArithmeticIfStmt
	: IF '(' Expr ')' Label ',' Label ',' Label
	{
		$$ = make (ARITHMETIC_IF_STMT);
		$$->ArithmeticIfStmt.If = &If;
		$$->ArithmeticIfStmt.Lp = &Lp;
		$$->ArithmeticIfStmt.Expr = $3;
		$$->ArithmeticIfStmt.Rp = &Rp;
		$$->ArithmeticIfStmt.Label = $5;
		$$->ArithmeticIfStmt.Comma = &Comma;
		$$->ArithmeticIfStmt.Label1 = $7;
		$$->ArithmeticIfStmt.Comma1 = &Comma;
		$$->ArithmeticIfStmt.Label2 = $9;
	}
	| IF LPEQI Expr ')' Label ',' Label ',' Label
	{
		$$ = make (ARITHMETIC_IF_STMT);
		$$->ArithmeticIfStmt.If = &If;
		$$->ArithmeticIfStmt.Lpeqi = &Lpeqi;
		$$->ArithmeticIfStmt.Expr = $3;
		$$->ArithmeticIfStmt.Rp = &Rp;
		$$->ArithmeticIfStmt.Label = $5;
		$$->ArithmeticIfStmt.Comma = &Comma;
		$$->ArithmeticIfStmt.Label1 = $7;
		$$->ArithmeticIfStmt.Comma1 = &Comma;
		$$->ArithmeticIfStmt.Label2 = $9;
	{
		$$->ArithmeticIfStmt.Lpeqi = NN;
		$$->ArithmeticIfStmt.Lp = &Lp;
	}
	}
	;

AssignStmt
	: ASSIGN Label TO Variable
	{
		$$ = make (ASSIGN_STMT);
		$$->AssignStmt.Assign = &Assign;
		$$->AssignStmt.Label = $2;
		$$->AssignStmt.To = &To;
		$$->AssignStmt.Variable = $4;
	}
	;

AssignedGotoStmt
	: GO_TO NAME OptComma '(' LabelList ')'
	{
		$$ = make (ASSIGNED_GOTO_STMT);
		$$->AssignedGotoStmt.GoTo = &GoTo;
		$$->AssignedGotoStmt.Name = $2;
		$$->AssignedGotoStmt.OptComma = $3;
		$$->AssignedGotoStmt.Lp = &Lp;
		$$->AssignedGotoStmt.LabelList = $5;
		$$->AssignedGotoStmt.Rp = &Rp;
	}
	| GO_TO NAME
	{
		$$ = make (ASSIGNED_GOTO_STMT);
		$$->AssignedGotoStmt.GoTo = &GoTo;
		$$->AssignedGotoStmt.Name = $2;
	}
	;

PauseStmt
	: PAUSE StopCode
	{
		$$ = make (PAUSE_STMT);
		$$->PauseStmt.Pause = &Pause;
		$$->PauseStmt.StopCode = $2;
	}
	| PAUSE
	{
		$$ = make (PAUSE_STMT);
		$$->PauseStmt.Pause = &Pause;
	}
	;

EndStmt
	: END
	{
		$$ = make (END_STMT);
		$$->EndStmt.End = &End;
	}
	;

ProgramStmt
	: KPROGRAM NAME
	{
		$$ = make (PROGRAM_STMT);
		$$->ProgramStmt.Kprogram = &Kprogram;
		$$->ProgramStmt.Name = $2;
	{
		install_glo ($2->com.str, TAB_NAME, 0);
	}
	}
	;

SubroutineStmt
	: OptRecursive SUBROUTINE NAME '(' OptDummyArgList ')'
	{
		$$ = make (SUBROUTINE_STMT);
		$$->SubroutineStmt.OptRecursive = $1;
		$$->SubroutineStmt.Subroutine = &Subroutine;
		$$->SubroutineStmt.Name = $3;
		$$->SubroutineStmt.Lp = &Lp;
		$$->SubroutineStmt.OptDummyArgList = $5;
		$$->SubroutineStmt.Rp = &Rp;
	}
	| OptRecursive SUBROUTINE NAME
	{
		$$ = make (SUBROUTINE_STMT);
		$$->SubroutineStmt.OptRecursive = $1;
		$$->SubroutineStmt.Subroutine = &Subroutine;
		$$->SubroutineStmt.Name = $3;
	}
	;

FunctionStmt
	: opt31 FUNCTION NAME '(' OptNameList ')' opt33
	{
		$$ = make (FUNCTION_STMT);
		$$->FunctionStmt.opt31 = $1;
		$$->FunctionStmt.Function = &Function;
		$$->FunctionStmt.Name = $3;
		$$->FunctionStmt.Lp = &Lp;
		$$->FunctionStmt.OptNameList = $5;
		$$->FunctionStmt.Rp = &Rp;
		$$->FunctionStmt.opt33 = $7;
	}
	| opt31 FUNCTION NAME
	{
		$$ = make (FUNCTION_STMT);
		$$->FunctionStmt.opt31 = $1;
		$$->FunctionStmt.Function = &Function;
		$$->FunctionStmt.Name = $3;
	{
		warning ("missing parenthesis in FUNCTION statement");
	}
	}
	;

IntrinsicStmt
	: INTRINSIC NameList
	{
		$$ = make (INTRINSIC_STMT);
		$$->IntrinsicStmt.Intrinsic = &Intrinsic;
		$$->IntrinsicStmt.NameList = $2;
	}
	;

IntentStmt
	: INTENT '(' NAME ')' ':' ':' NameList
	{
		$$ = make (INTENT_STMT);
		$$->IntentStmt.Intent = &Intent;
		$$->IntentStmt.Lp = &Lp;
		$$->IntentStmt.Name = $3;
		$$->IntentStmt.Rp = &Rp;
		$$->IntentStmt.Colon = &Colon;
		$$->IntentStmt.Colon1 = &Colon;
		$$->IntentStmt.NameList = $7;
	{
		yacc_IntentStmt ($$);
	}
	}
	| INTENT '(' NAME ')' NameList
	{
		$$ = make (INTENT_STMT);
		$$->IntentStmt.Intent = &Intent;
		$$->IntentStmt.Lp = &Lp;
		$$->IntentStmt.Name = $3;
		$$->IntentStmt.Rp = &Rp;
		$$->IntentStmt.NameList = $5;
	{
		yacc_IntentStmt ($$);
	}
	}
	;

OptionalStmt
	: OPTIONAL ':' ':' NameList
	{
		$$ = make (OPTIONAL_STMT);
		$$->OptionalStmt.Optional = &Optional;
		$$->OptionalStmt.Colon = &Colon;
		$$->OptionalStmt.Colon1 = &Colon;
		$$->OptionalStmt.NameList = $4;
	}
	;

AccessStmt
	: AccessSpec OptCC NameList
	{$$ = make (ACCESS_STMT);}

	| AccessSpec
	{$$ = make (ACCESS_STMT);}

	;

SaveStmt
	: SAVE OptCC SavedEntityList
	{
		$$ = make (SAVE_STMT);
		$$->SaveStmt.Save = &Save;
		$$->SaveStmt.OptCC = $2;
		$$->SaveStmt.SavedEntityList = $3;
	{
		$$->SaveStmt.OptCC = NN;
	}
	}
	| SAVE
	{
		$$ = make (SAVE_STMT);
		$$->SaveStmt.Save = &Save;
	}
	;

AllocatableStmt
	: ALLOCATABLE OptCC EntityAllocatableList
	{$$ = make (ALLOCATABLE_STMT);}

	;

PointerStmt
	: POINTER OptCC EntityAllocatableList
	{$$ = make (POINTER_STMT);}

	;

TargetStmt
	: KTARGET OptCC EntityTargetList
	{$$ = make (TARGET_STMT);}

	;

NamelistStmt
	: NAMELIST '/' NAME '/' NameList
	{
		$$ = make (NAMELIST_STMT);
		$$->NamelistStmt.Namelist = &Namelist;
		$$->NamelistStmt.Slash = &Slash;
		$$->NamelistStmt.Name = $3;
		$$->NamelistStmt.Slash1 = &Slash;
		$$->NamelistStmt.NameList = $5;
	}
	| NamelistStmt '/' NAME '/' NameList
	{
		$$ = make (NAMELIST_STMT);
		$$->NamelistStmt.NamelistStmt = $1;
		$$->NamelistStmt.Slash = &Slash;
		$$->NamelistStmt.Name = $3;
		$$->NamelistStmt.Slash1 = &Slash;
		$$->NamelistStmt.NameList = $5;
	}
	;

AllocateStmt
	: ALLOCATE '(' AllocationList ',' NAME '=' Variable ')'
	{$$ = make (ALLOCATE_STMT);}

	| ALLOCATE LPEQI AllocationList ',' NAME '=' Variable ')'
	{$$ = make (ALLOCATE_STMT);}

	| ALLOCATE '(' AllocationList ')'
	{$$ = make (ALLOCATE_STMT);}

	;

NullifyStmt
	: NULLIFY '(' NameList ')'
	{$$ = make (NULLIFY_STMT);}

	;

DeallocateStmt
	: DEALLOCATE '(' AllocateObjectList ',' NAME '=' Variable ')'
	{$$ = make (DEALLOCATE_STMT);}

	| DEALLOCATE LPEQI AllocateObjectList ',' NAME '=' Variable ')'
	{$$ = make (DEALLOCATE_STMT);}

	| DEALLOCATE '(' AllocateObjectList ')'
	{$$ = make (DEALLOCATE_STMT);}

	;

PointerAssignementStmt
	: NAME POINT_OP Target
	{$$ = make (POINTER_ASSIGNEMENT_STMT);}

	;

WhereStmt
	: WHERE '(' Expr ')' AssignementStmt
	{
		$$ = make (WHERE_STMT);
		$$->WhereStmt.Where = &Where;
		$$->WhereStmt.Lp = &Lp;
		$$->WhereStmt.Expr = $3;
		$$->WhereStmt.Rp = &Rp;
		$$->WhereStmt.AssignementStmt = $5;
	}
	| WHERE LPEQI Expr ')' AssignementStmt
	{
		$$ = make (WHERE_STMT);
		$$->WhereStmt.Where = &Where;
		$$->WhereStmt.Lpeqi = &Lpeqi;
		$$->WhereStmt.Expr = $3;
		$$->WhereStmt.Rp = &Rp;
		$$->WhereStmt.AssignementStmt = $5;
	{
		$$->WhereStmt.Lp = &Lp;
		$$->WhereStmt.Lpeqi = NN;
	}
	}
	;

WhereConstructStmt
	: WHERE '(' Expr ')'
	{
		$$ = make (WHERE_CONSTRUCT_STMT);
		$$->WhereConstructStmt.Where = &Where;
		$$->WhereConstructStmt.Lp = &Lp;
		$$->WhereConstructStmt.Expr = $3;
		$$->WhereConstructStmt.Rp = &Rp;
	}
	| WHERE LPEQI Expr ')'
	{
		$$ = make (WHERE_CONSTRUCT_STMT);
		$$->WhereConstructStmt.Where = &Where;
		$$->WhereConstructStmt.Lpeqi = &Lpeqi;
		$$->WhereConstructStmt.Expr = $3;
		$$->WhereConstructStmt.Rp = &Rp;
	{
		$$->WhereConstructStmt.Lp = &Lp;
		$$->WhereConstructStmt.Lpeqi = NN;
	}
	}
	;

ElsewhereStmt
	: ELSE_WHERE
	{
		$$ = make (ELSEWHERE_STMT);
		$$->ElsewhereStmt.ElseWhere = &ElseWhere;
	}
	;

EndWhereStmt
	: END_WHERE
	{
		$$ = make (END_WHERE_STMT);
		$$->EndWhereStmt.EndWhere = &EndWhere;
	}
	;

SelectCaseStmt
	: SELECT NAME '(' Expr ')'
	{
		$$ = make (SELECT_CASE_STMT);
		$$->SelectCaseStmt.Select = &Select;
		$$->SelectCaseStmt.Name = $2;
		$$->SelectCaseStmt.Lp = &Lp;
		$$->SelectCaseStmt.Expr = $4;
		$$->SelectCaseStmt.Rp = &Rp;
	{
		key_check ($2, "CASE");
	}
	}
	| NAME ':' SELECT NAME '(' Expr ')'
	{
		$$ = make (SELECT_CASE_STMT);
		$$->SelectCaseStmt.Name = $1;
		$$->SelectCaseStmt.Colon = &Colon;
		$$->SelectCaseStmt.Select = &Select;
		$$->SelectCaseStmt.Name1 = $4;
		$$->SelectCaseStmt.Lp = &Lp;
		$$->SelectCaseStmt.Expr = $6;
		$$->SelectCaseStmt.Rp = &Rp;
	{
		key_check ($4, "CASE");
	}
	}
	;

CaseStmt
	: CASE CaseSelector NAME
	{
		$$ = make (CASE_STMT);
		$$->CaseStmt.Case = &Case;
		$$->CaseStmt.CaseSelector = $2;
		$$->CaseStmt.Name = $3;
	}
	| CASE CaseSelector
	{
		$$ = make (CASE_STMT);
		$$->CaseStmt.Case = &Case;
		$$->CaseStmt.CaseSelector = $2;
	{
		char *name;

		if ($2->CaseSelector.Name != NN
		&&  (name = key_check ($2->CaseSelector.Name, "DEFAULT")) != CN)
			$$->CaseStmt.Name = make_Name (name);
	}
	}
	;

EndSelectStmt
	: END_SELECT NAME
	{
		$$ = make (END_SELECT_STMT);
		$$->EndSelectStmt.EndSelect = &EndSelect;
		$$->EndSelectStmt.Name = $2;
	}
	| END_SELECT
	{
		$$ = make (END_SELECT_STMT);
		$$->EndSelectStmt.EndSelect = &EndSelect;
	}
	;

ExitStmt
	: EXIT NAME
	{
		$$ = make (EXIT_STMT);
		$$->ExitStmt.Exit = &Exit;
		$$->ExitStmt.Name = $2;
	}
	| EXIT
	{
		$$ = make (EXIT_STMT);
		$$->ExitStmt.Exit = &Exit;
	}
	;

CycleStmt
	: CYCLE NAME
	{
		$$ = make (CYCLE_STMT);
		$$->CycleStmt.Cycle = &Cycle;
		$$->CycleStmt.Name = $2;
	}
	| CYCLE
	{
		$$ = make (CYCLE_STMT);
		$$->CycleStmt.Cycle = &Cycle;
	}
	;

EndProgramStmt
	: END_PROGRAM NAME
	{
		$$ = make (END_PROGRAM_STMT);
		$$->EndProgramStmt.EndProgram = &EndProgram;
		$$->EndProgramStmt.Name = $2;
	}
	| END_PROGRAM
	{
		$$ = make (END_PROGRAM_STMT);
		$$->EndProgramStmt.EndProgram = &EndProgram;
	}
	;

ModuleStmt
	: MODULE NAME
	{
		$$ = make (MODULE_STMT);
		$$->ModuleStmt.Module = &Module;
		$$->ModuleStmt.Name = $2;
	}
	;

EndModuleStmt
	: END_MODULE NAME
	{
		$$ = make (END_MODULE_STMT);
		$$->EndModuleStmt.EndModule = &EndModule;
		$$->EndModuleStmt.Name = $2;
	}
	| END_MODULE
	{
		$$ = make (END_MODULE_STMT);
		$$->EndModuleStmt.EndModule = &EndModule;
	}
	;

UseStmt
	: USE NAME
	{
		$$ = make (USE_STMT);
		$$->UseStmt.Use = &Use;
		$$->UseStmt.Name = $2;
	}
	| USE NAME ',' RenameList
	{
		$$ = make (USE_STMT);
		$$->UseStmt.Use = &Use;
		$$->UseStmt.Name = $2;
		$$->UseStmt.Comma = &Comma;
		$$->UseStmt.RenameList = $4;
	}
	| USE NAME ',' NAME ':' OnlyList
	{
		$$ = make (USE_STMT);
		$$->UseStmt.Use = &Use;
		$$->UseStmt.Name = $2;
		$$->UseStmt.Comma = &Comma;
		$$->UseStmt.Name1 = $4;
		$$->UseStmt.Colon = &Colon;
		$$->UseStmt.OnlyList = $6;
	}
	;

BlockDataStmt
	: BLOCK_DATA NAME
	{
		$$ = make (BLOCK_DATA_STMT);
		$$->BlockDataStmt.BlockData = &BlockData;
		$$->BlockDataStmt.Name = $2;
	}
	| BLOCK_DATA
	{
		$$ = make (BLOCK_DATA_STMT);
		$$->BlockDataStmt.BlockData = &BlockData;
	}
	;

EndBlockDataStmt
	: END_BLOCK_DATA NAME
	{
		$$ = make (END_BLOCK_DATA_STMT);
		$$->EndBlockDataStmt.EndBlockData = &EndBlockData;
		$$->EndBlockDataStmt.Name = $2;
	}
	| END_BLOCK_DATA
	{
		$$ = make (END_BLOCK_DATA_STMT);
		$$->EndBlockDataStmt.EndBlockData = &EndBlockData;
	}
	;

InterfaceStmt
	: INTERFACE GenericSpec
	{
		$$ = &IgnoreStmt;

		if (se_in_interface) {
			warning (
			"INTERFACE within INTERFACE, all but the type of the procedure ignored");
			se_interfaces_within_interfaces++;
		}
		else {
			se_in_interface = 1;
			push_scope ();
			state_level++;
			over_begin ($2);
		}
	}

	;

EndInterfaceStmt
	: END_INTERFACE
	{
		if (se_interfaces_within_interfaces) {
			$$ = &EndInterface;

			goto skip_rest_EndInterface;
		}

		$$ = &IgnoreStmt;

		if (state [state_level] != UNIT_OUT) {
			warning ("missing END statement");
			order_enddecl_parse ();

			order_reset_states ();

			current_pass = PASS_WRITE;
			proc_end_before_write ();
			proc_end_after_write ();
			current_pass = PASS_PARSE;
		}

		if (se_in_interface) {
			se_in_interface = 0;
			over_end ();
			pop_scope ();
			state_level--;
		}
		else
			fatal ("END INTERFACE statement not in INTERFACE body");

		skip_rest_EndInterface:;
	}

	;

ModuleProcedureStmt
	: MODULE NAME NameList
	{
		$$ = make (MODULE_PROCEDURE_STMT);
		$$->ModuleProcedureStmt.Module = &Module;
		$$->ModuleProcedureStmt.Name = $2;
		$$->ModuleProcedureStmt.NameList = $3;
	{
		key_check ($2, "PROCEDURE");
	}
	}
	;

EndFunctionStmt
	: END_FUNCTION NAME
	{
		$$ = make (END_FUNCTION_STMT);
		$$->EndFunctionStmt.EndFunction = &EndFunction;
		$$->EndFunctionStmt.Name = $2;
	}
	| END_FUNCTION
	{
		$$ = make (END_FUNCTION_STMT);
		$$->EndFunctionStmt.EndFunction = &EndFunction;
	}
	;

EndSubroutineStmt
	: END_SUBROUTINE NAME
	{
		$$ = make (END_SUBROUTINE_STMT);
		$$->EndSubroutineStmt.EndSubroutine = &EndSubroutine;
		$$->EndSubroutineStmt.Name = $2;
	}
	| END_SUBROUTINE
	{
		$$ = make (END_SUBROUTINE_STMT);
		$$->EndSubroutineStmt.EndSubroutine = &EndSubroutine;
	}
	;

ContainsStmt
	: CONTAINS
	{$$ = make (CONTAINS_STMT);}

	;

ForallStmt
	: FORALL '(' ForallTripletSpecList OptScalarMaskExpr ')' Stmt
	{
		$$ = make (FORALL_STMT);
		$$->ForallStmt.Forall = &Forall;
		$$->ForallStmt.Lp = &Lp;
		$$->ForallStmt.ForallTripletSpecList = $3;
		$$->ForallStmt.OptScalarMaskExpr = $4;
		$$->ForallStmt.Rp = &Rp;
		$$->ForallStmt.Stmt = $6;
	{
		stand ("FORALL statement");
	}
	}
	| FORALL LPEQI ForallTripletSpecList OptScalarMaskExpr ')' Stmt
	{
		$$ = make (FORALL_STMT);
		$$->ForallStmt.Forall = &Forall;
		$$->ForallStmt.Lpeqi = &Lpeqi;
		$$->ForallStmt.ForallTripletSpecList = $3;
		$$->ForallStmt.OptScalarMaskExpr = $4;
		$$->ForallStmt.Rp = &Rp;
		$$->ForallStmt.Stmt = $6;
	{
		stand ("FORALL statement");

		$$->ForallStmt.Lp = &Lp;
		$$->ForallStmt.Lpeqi = NN;
	}
	}
	;

IncludeStmt
	: INCLUDE CHARACTER_CONSTANT
	{
		$$ = make (INCLUDE_STMT);
		$$->IncludeStmt.Include = &Include;
		$$->IncludeStmt.CharacterConstant = $2;
	}
	;

DirectiveStmt
	: DIRDECOMPOSE DecomposeList
	{
		$$ = make (DIRECTIVE_STMT);
		$$->DirectiveStmt.Dirdecompose = &Dirdecompose;
		$$->DirectiveStmt.DecomposeList = $2;
	}
	| DIRDISTRIBUTE DistributeList
	{
		$$ = make (DIRECTIVE_STMT);
		$$->DirectiveStmt.Dirdistribute = &Dirdistribute;
		$$->DirectiveStmt.DistributeList = $2;
	}
	| DIRALIGN AlignStuff
	{
		$$ = make (DIRECTIVE_STMT);
		$$->DirectiveStmt.Diralign = &Diralign;
		$$->DirectiveStmt.AlignStuff = $2;
	}
	| DIRPROCESSORS OptCC ProcsDeclList
	{
		$$ = make (DIRECTIVE_STMT);
		$$->DirectiveStmt.Dirprocessors = &Dirprocessors;
		$$->DirectiveStmt.OptCC = $2;
		$$->DirectiveStmt.ProcsDeclList = $3;
	}
	;

ForallConstructStmt
	: MFORALL '(' ForallTripletSpecList OptScalarMaskExpr ')'
	{
		$$ = make (FORALL_CONSTRUCT_STMT);
		$$->ForallConstructStmt.Mforall = &Mforall;
		$$->ForallConstructStmt.Lp = &Lp;
		$$->ForallConstructStmt.ForallTripletSpecList = $3;
		$$->ForallConstructStmt.OptScalarMaskExpr = $4;
		$$->ForallConstructStmt.Rp = &Rp;
	{
                stand ("FORALL CONSTRUCT statement");
        }
	}
	| MFORALL LPEQI ForallTripletSpecList OptScalarMaskExpr ')'
	{
		$$ = make (FORALL_CONSTRUCT_STMT);
		$$->ForallConstructStmt.Mforall = &Mforall;
		$$->ForallConstructStmt.Lpeqi = &Lpeqi;
		$$->ForallConstructStmt.ForallTripletSpecList = $3;
		$$->ForallConstructStmt.OptScalarMaskExpr = $4;
		$$->ForallConstructStmt.Rp = &Rp;
	{
                stand ("FORALL CONSTRUCT statement");

                $$->ForallConstructStmt.Lp = &Lp;
                $$->ForallConstructStmt.Lpeqi = NN;
        }
	}
	;

EndForallStmt
	: ENDFORALL NAME
	{
		$$ = make (END_FORALL_STMT);
		$$->EndForallStmt.Endforall = &Endforall;
		$$->EndForallStmt.Name = $2;
	}
	| ENDFORALL
	{
		$$ = make (END_FORALL_STMT);
		$$->EndForallStmt.Endforall = &Endforall;
	}
	;

ExDirectiveStmt
	: EXDIRCONSTRUCT DistSpec '(' Size ',' LinkInfo ',' GeoInfo ',' LoadInfo ')'
	{
		$$ = make (EX_DIRECTIVE_STMT);
		$$->ExDirectiveStmt.Exdirconstruct = &Exdirconstruct;
		$$->ExDirectiveStmt.DistSpec = $2;
		$$->ExDirectiveStmt.Lp = &Lp;
		$$->ExDirectiveStmt.Size = $4;
		$$->ExDirectiveStmt.Comma = &Comma;
		$$->ExDirectiveStmt.LinkInfo = $6;
		$$->ExDirectiveStmt.Comma1 = &Comma;
		$$->ExDirectiveStmt.GeoInfo = $8;
		$$->ExDirectiveStmt.Comma2 = &Comma;
		$$->ExDirectiveStmt.LoadInfo = $10;
		$$->ExDirectiveStmt.Rp = &Rp;
	}
	| EXDIRCONSTRUCT DistSpec '(' Size ',' LinkInfo ',' LoadInfo ')'
	{
		$$ = make (EX_DIRECTIVE_STMT);
		$$->ExDirectiveStmt.Exdirconstruct = &Exdirconstruct;
		$$->ExDirectiveStmt.DistSpec = $2;
		$$->ExDirectiveStmt.Lp = &Lp;
		$$->ExDirectiveStmt.Size = $4;
		$$->ExDirectiveStmt.Comma = &Comma;
		$$->ExDirectiveStmt.LinkInfo = $6;
		$$->ExDirectiveStmt.Comma1 = &Comma;
		$$->ExDirectiveStmt.LoadInfo = $8;
		$$->ExDirectiveStmt.Rp = &Rp;
	}
	| EXDIRCONSTRUCT DistSpec '(' Size ',' LinkInfo ',' GeoInfo ')'
	{
		$$ = make (EX_DIRECTIVE_STMT);
		$$->ExDirectiveStmt.Exdirconstruct = &Exdirconstruct;
		$$->ExDirectiveStmt.DistSpec = $2;
		$$->ExDirectiveStmt.Lp = &Lp;
		$$->ExDirectiveStmt.Size = $4;
		$$->ExDirectiveStmt.Comma = &Comma;
		$$->ExDirectiveStmt.LinkInfo = $6;
		$$->ExDirectiveStmt.Comma1 = &Comma;
		$$->ExDirectiveStmt.GeoInfo = $8;
		$$->ExDirectiveStmt.Rp = &Rp;
	}
	| EXDIRCONSTRUCT DistSpec '(' Size ',' LoadInfo ',' GeoInfo ')'
	{
		$$ = make (EX_DIRECTIVE_STMT);
		$$->ExDirectiveStmt.Exdirconstruct = &Exdirconstruct;
		$$->ExDirectiveStmt.DistSpec = $2;
		$$->ExDirectiveStmt.Lp = &Lp;
		$$->ExDirectiveStmt.Size = $4;
		$$->ExDirectiveStmt.Comma = &Comma;
		$$->ExDirectiveStmt.LoadInfo = $6;
		$$->ExDirectiveStmt.Comma1 = &Comma;
		$$->ExDirectiveStmt.GeoInfo = $8;
		$$->ExDirectiveStmt.Rp = &Rp;
	}
	| EXDIRCONSTRUCT DistSpec '(' Size ',' GeoInfo ')'
	{
		$$ = make (EX_DIRECTIVE_STMT);
		$$->ExDirectiveStmt.Exdirconstruct = &Exdirconstruct;
		$$->ExDirectiveStmt.DistSpec = $2;
		$$->ExDirectiveStmt.Lp = &Lp;
		$$->ExDirectiveStmt.Size = $4;
		$$->ExDirectiveStmt.Comma = &Comma;
		$$->ExDirectiveStmt.GeoInfo = $6;
		$$->ExDirectiveStmt.Rp = &Rp;
	}
	| EXDIRCONSTRUCT DistSpec '(' Size ',' LoadInfo ')'
	{
		$$ = make (EX_DIRECTIVE_STMT);
		$$->ExDirectiveStmt.Exdirconstruct = &Exdirconstruct;
		$$->ExDirectiveStmt.DistSpec = $2;
		$$->ExDirectiveStmt.Lp = &Lp;
		$$->ExDirectiveStmt.Size = $4;
		$$->ExDirectiveStmt.Comma = &Comma;
		$$->ExDirectiveStmt.LoadInfo = $6;
		$$->ExDirectiveStmt.Rp = &Rp;
	}
	| EXDIRCONSTRUCT DistSpec '(' Size ',' LinkInfo ')'
	{
		$$ = make (EX_DIRECTIVE_STMT);
		$$->ExDirectiveStmt.Exdirconstruct = &Exdirconstruct;
		$$->ExDirectiveStmt.DistSpec = $2;
		$$->ExDirectiveStmt.Lp = &Lp;
		$$->ExDirectiveStmt.Size = $4;
		$$->ExDirectiveStmt.Comma = &Comma;
		$$->ExDirectiveStmt.LinkInfo = $6;
		$$->ExDirectiveStmt.Rp = &Rp;
	{
                stand("CONSTRUCT statement");
        }
	}
	| PartCall
	{
		$$ = make (EX_DIRECTIVE_STMT);
		$$->ExDirectiveStmt.PartCall = $1;
	}
	| EXDIRREDISTRIBUTE DistributeSpec
	{
		$$ = make (EX_DIRECTIVE_STMT);
		$$->ExDirectiveStmt.Exdirredistribute = &Exdirredistribute;
		$$->ExDirectiveStmt.DistributeSpec = $2;
	}
	;

BsDirectiveStmt
	: DIRFVPROC Expr ',' Expr ',' Expr
	{
		$$ = make (BS_DIRECTIVE_STMT);
		$$->BsDirectiveStmt.Dirfvproc = &Dirfvproc;
		$$->BsDirectiveStmt.Expr = $2;
		$$->BsDirectiveStmt.Comma = &Comma;
		$$->BsDirectiveStmt.Expr1 = $4;
		$$->BsDirectiveStmt.Comma1 = &Comma;
		$$->BsDirectiveStmt.Expr2 = $6;
	}
	| DIRFDECOMP Expr ',' Expr ',' Expr
	{
		$$ = make (BS_DIRECTIVE_STMT);
		$$->BsDirectiveStmt.Dirfdecomp = &Dirfdecomp;
		$$->BsDirectiveStmt.Expr = $2;
		$$->BsDirectiveStmt.Comma = &Comma;
		$$->BsDirectiveStmt.Expr1 = $4;
		$$->BsDirectiveStmt.Comma1 = &Comma;
		$$->BsDirectiveStmt.Expr2 = $6;
	}
	| DIRFEMBED Expr ',' Expr ',' Expr ',' Expr
	{
		$$ = make (BS_DIRECTIVE_STMT);
		$$->BsDirectiveStmt.Dirfembed = &Dirfembed;
		$$->BsDirectiveStmt.Expr = $2;
		$$->BsDirectiveStmt.Comma = &Comma;
		$$->BsDirectiveStmt.Expr1 = $4;
		$$->BsDirectiveStmt.Comma1 = &Comma;
		$$->BsDirectiveStmt.Expr2 = $6;
		$$->BsDirectiveStmt.Comma2 = &Comma;
		$$->BsDirectiveStmt.Expr3 = $8;
	}
	| DIRFDISTRIBUTE Expr ',' Expr
	{
		$$ = make (BS_DIRECTIVE_STMT);
		$$->BsDirectiveStmt.Dirfdistribute = &Dirfdistribute;
		$$->BsDirectiveStmt.Expr = $2;
		$$->BsDirectiveStmt.Comma = &Comma;
		$$->BsDirectiveStmt.Expr1 = $4;
	}
	| DIRFALIGN NAME ',' NAME ',' Expr ',' Expr ',' Expr ',' Expr ',' Expr ',' Expr ',' Expr
	{
		$$ = make (BS_DIRECTIVE_STMT);
		$$->BsDirectiveStmt.Dirfalign = &Dirfalign;
		$$->BsDirectiveStmt.Name = $2;
		$$->BsDirectiveStmt.Comma = &Comma;
		$$->BsDirectiveStmt.Name1 = $4;
		$$->BsDirectiveStmt.Comma1 = &Comma;
		$$->BsDirectiveStmt.Expr = $6;
		$$->BsDirectiveStmt.Comma2 = &Comma;
		$$->BsDirectiveStmt.Expr1 = $8;
		$$->BsDirectiveStmt.Comma3 = &Comma;
		$$->BsDirectiveStmt.Expr2 = $10;
		$$->BsDirectiveStmt.Comma4 = &Comma;
		$$->BsDirectiveStmt.Expr3 = $12;
		$$->BsDirectiveStmt.Comma5 = &Comma;
		$$->BsDirectiveStmt.Expr4 = $14;
		$$->BsDirectiveStmt.Comma6 = &Comma;
		$$->BsDirectiveStmt.Expr5 = $16;
		$$->BsDirectiveStmt.Comma7 = &Comma;
		$$->BsDirectiveStmt.Expr6 = $18;
	}
	| DIRISDAD NAME ',' NAME
	{
		$$ = make (BS_DIRECTIVE_STMT);
		$$->BsDirectiveStmt.Dirisdad = &Dirisdad;
		$$->BsDirectiveStmt.Name = $2;
		$$->BsDirectiveStmt.Comma = &Comma;
		$$->BsDirectiveStmt.Name1 = $4;
	}
	| DIRISDECOMP NAME ',' NAME
	{
		$$ = make (BS_DIRECTIVE_STMT);
		$$->BsDirectiveStmt.Dirisdecomp = &Dirisdecomp;
		$$->BsDirectiveStmt.Name = $2;
		$$->BsDirectiveStmt.Comma = &Comma;
		$$->BsDirectiveStmt.Name1 = $4;
	}
	;

SForallConstructStmt
	: SFORALL '(' ForallTripletSpecList OptScalarMaskExpr ')'
	{
		$$ = make (S_FORALL_CONSTRUCT_STMT);
		$$->SForallConstructStmt.Sforall = &Sforall;
		$$->SForallConstructStmt.Lp = &Lp;
		$$->SForallConstructStmt.ForallTripletSpecList = $3;
		$$->SForallConstructStmt.OptScalarMaskExpr = $4;
		$$->SForallConstructStmt.Rp = &Rp;
	{
                stand ("FORALL CONSTRUCT statement");
        }
	}
	| SFORALL LPEQI ForallTripletSpecList OptScalarMaskExpr ')'
	{
		$$ = make (S_FORALL_CONSTRUCT_STMT);
		$$->SForallConstructStmt.Sforall = &Sforall;
		$$->SForallConstructStmt.Lpeqi = &Lpeqi;
		$$->SForallConstructStmt.ForallTripletSpecList = $3;
		$$->SForallConstructStmt.OptScalarMaskExpr = $4;
		$$->SForallConstructStmt.Rp = &Rp;
	{
                stand ("FORALL CONSTRUCT statement");

                $$->SForallConstructStmt.Lp = &Lp;
                $$->SForallConstructStmt.Lpeqi = NN;
        }
	}
	;

SEndForallStmt
	: SENDFORALL NAME
	{
		$$ = make (S_END_FORALL_STMT);
		$$->SEndForallStmt.Sendforall = &Sendforall;
		$$->SEndForallStmt.Name = $2;
	}
	| SENDFORALL
	{
		$$ = make (S_END_FORALL_STMT);
		$$->SEndForallStmt.Sendforall = &Sendforall;
	}
	;

NiceStmt
	: SCHEDTYPE INTEGER_CONSTANT
	{
		$$ = make (NICE_STMT);
		$$->NiceStmt.Schedtype = &Schedtype;
		$$->NiceStmt.IntegerConstant = $2;
	}
	;

IndependentStmt
	: DIRINDEPENDENT
	{
		$$ = make (INDEPENDENT_STMT);
		$$->IndependentStmt.Dirindependent = &Dirindependent;
	}
	| DIRINDEPENDENT ',' '(' NameList ')'
	{
		$$ = make (INDEPENDENT_STMT);
		$$->IndependentStmt.Dirindependent = &Dirindependent;
		$$->IndependentStmt.Comma = &Comma;
		$$->IndependentStmt.Lp = &Lp;
		$$->IndependentStmt.NameList = $4;
		$$->IndependentStmt.Rp = &Rp;
	}
	;

PureStmt
	: DIRPURE
	{
		$$ = make (PURE_STMT);
		$$->PureStmt.Dirpure = &Dirpure;
	}
	| DIRINDEPENDENT ',' NameList
	{
		$$ = make (PURE_STMT);
		$$->PureStmt.Dirindependent = &Dirindependent;
		$$->PureStmt.Comma = &Comma;
		$$->PureStmt.NameList = $3;
	}
	;

ForallTripletSpecList
	: ForallTripletSpecList ',' ForallTripletSpec
	{
		$$ = make (FORALL_TRIPLET_SPEC_LIST);
		$$->ForallTripletSpecList.ForallTripletSpecList = $1;
		$$->ForallTripletSpecList.Comma = &Comma;
		$$->ForallTripletSpecList.ForallTripletSpec = $3;
	}
	| ForallTripletSpec
	{
		$$ = make (FORALL_TRIPLET_SPEC_LIST);
		$$->ForallTripletSpecList.ForallTripletSpec = $1;
	}
	;

OptScalarMaskExpr
	:
	{
		$$ = (Node*) 0;
	}
	| ',' Expr
	{
		$$ = make (OPT_SCALAR_MASK_EXPR);
		$$->OptScalarMaskExpr.Comma = &Comma;
		$$->OptScalarMaskExpr.Expr = $2;
	}
	;

DistSpec
	: DIRBLOCK
	{
		$$ = &Dirblock;
	}
	| DIRCYCLIC
	{
		$$ = &Dircyclic;
	}
	| ':'
	{
		$$ = &Colon;
	}
	| DIRMBLOCK
	{
		$$ = &Dirmblock;
	}
	| NAME
	;

Size
	: INTEGER_CONSTANT
	| NAME
	;

LinkInfo
	: LinkInfo ',' EXDIRLINK '(' Size ',' AlignSpec ',' AlignSpec ')'
	{
		$$ = make (LINK_INFO);
		$$->LinkInfo.LinkInfo = $1;
		$$->LinkInfo.Comma = &Comma;
		$$->LinkInfo.Exdirlink = &Exdirlink;
		$$->LinkInfo.Lp = &Lp;
		$$->LinkInfo.Size = $5;
		$$->LinkInfo.Comma1 = &Comma;
		$$->LinkInfo.AlignSpec = $7;
		$$->LinkInfo.Comma2 = &Comma;
		$$->LinkInfo.AlignSpec1 = $9;
		$$->LinkInfo.Rp = &Rp;
	}
	| LinkInfo ',' EXDIRLINK LPEQI Size ',' AlignSpec ',' AlignSpec ')'
	{
		$$ = make (LINK_INFO);
		$$->LinkInfo.LinkInfo = $1;
		$$->LinkInfo.Comma = &Comma;
		$$->LinkInfo.Exdirlink = &Exdirlink;
		$$->LinkInfo.Lpeqi = &Lpeqi;
		$$->LinkInfo.Size = $5;
		$$->LinkInfo.Comma1 = &Comma;
		$$->LinkInfo.AlignSpec = $7;
		$$->LinkInfo.Comma2 = &Comma;
		$$->LinkInfo.AlignSpec1 = $9;
		$$->LinkInfo.Rp = &Rp;
	}
	| EXDIRLINK '(' Size ',' AlignSpec ',' AlignSpec ')'
	{
		$$ = make (LINK_INFO);
		$$->LinkInfo.Exdirlink = &Exdirlink;
		$$->LinkInfo.Lp = &Lp;
		$$->LinkInfo.Size = $3;
		$$->LinkInfo.Comma = &Comma;
		$$->LinkInfo.AlignSpec = $5;
		$$->LinkInfo.Comma1 = &Comma;
		$$->LinkInfo.AlignSpec1 = $7;
		$$->LinkInfo.Rp = &Rp;
	}
	| EXDIRLINK LPEQI Size ',' AlignSpec ',' AlignSpec ')'
	{
		$$ = make (LINK_INFO);
		$$->LinkInfo.Exdirlink = &Exdirlink;
		$$->LinkInfo.Lpeqi = &Lpeqi;
		$$->LinkInfo.Size = $3;
		$$->LinkInfo.Comma = &Comma;
		$$->LinkInfo.AlignSpec = $5;
		$$->LinkInfo.Comma1 = &Comma;
		$$->LinkInfo.AlignSpec1 = $7;
		$$->LinkInfo.Rp = &Rp;
	}
	;

GeoInfo
	: EXDIRGEOMETRY '(' Size ',' GeoArray ')'
	{
		$$ = make (GEO_INFO);
		$$->GeoInfo.Exdirgeometry = &Exdirgeometry;
		$$->GeoInfo.Lp = &Lp;
		$$->GeoInfo.Size = $3;
		$$->GeoInfo.Comma = &Comma;
		$$->GeoInfo.GeoArray = $5;
		$$->GeoInfo.Rp = &Rp;
	}
	;

LoadInfo
	: EXDIRLOAD '(' AlignSpec ')'
	{
		$$ = make (LOAD_INFO);
		$$->LoadInfo.Exdirload = &Exdirload;
		$$->LoadInfo.Lp = &Lp;
		$$->LoadInfo.AlignSpec = $3;
		$$->LoadInfo.Rp = &Rp;
	}
	;

PartCall
	: EXDIRSET DistSpec EXDIRBY EXDIRPARTITION DistSpec EXDIRUSING DistSpec
	{
		$$ = make (PART_CALL);
		$$->PartCall.Exdirset = &Exdirset;
		$$->PartCall.DistSpec = $2;
		$$->PartCall.Exdirby = &Exdirby;
		$$->PartCall.Exdirpartition = &Exdirpartition;
		$$->PartCall.DistSpec1 = $5;
		$$->PartCall.Exdirusing = &Exdirusing;
		$$->PartCall.DistSpec2 = $7;
	}
	;

DistributeSpec
	: NAME '(' DistList ')'
	{
		$$ = make (DISTRIBUTE_SPEC);
		$$->DistributeSpec.Name = $1;
		$$->DistributeSpec.Lp = &Lp;
		$$->DistributeSpec.DistList = $3;
		$$->DistributeSpec.Rp = &Rp;
	}
	;

GeoArray
	: GeoArray ',' AlignSpec
	{
		$$ = make (GEO_ARRAY);
		$$->GeoArray.GeoArray = $1;
		$$->GeoArray.Comma = &Comma;
		$$->GeoArray.AlignSpec = $3;
	}
	| AlignSpec
	{
		$$ = make (GEO_ARRAY);
		$$->GeoArray.AlignSpec = $1;
	}
	;

AlignSpec
	: NAME '(' SubscriptList ')'
	{
		$$ = make (ALIGN_SPEC);
		$$->AlignSpec.Name = $1;
		$$->AlignSpec.Lp = &Lp;
		$$->AlignSpec.SubscriptList = $3;
		$$->AlignSpec.Rp = &Rp;
	}
	| NAME
	{
		$$ = make (ALIGN_SPEC);
		$$->AlignSpec.Name = $1;
	}
	| '*' NAME '(' SubscriptList ')'
	{
		$$ = make (ALIGN_SPEC);
		$$->AlignSpec.Times = &Times;
		$$->AlignSpec.Name = $2;
		$$->AlignSpec.Lp = &Lp;
		$$->AlignSpec.SubscriptList = $4;
		$$->AlignSpec.Rp = &Rp;
	}
	| '*' NAME
	{
		$$ = make (ALIGN_SPEC);
		$$->AlignSpec.Times = &Times;
		$$->AlignSpec.Name = $2;
	}
	| '*'
	{
		$$ = make (ALIGN_SPEC);
		$$->AlignSpec.Times = &Times;
	}
	;

Expr
	: Expr DEFINED_UNARY_OP Level5Expr
	{
		$$ = make_DumExpr ($1, &DefinedUnaryOp, $3);
	}

	| Level5Expr
	{
		$$ = $1;
	}

	;

DecomposeList
	: DecomposeList ',' DecomposeSpec
	{
		$$ = make (DECOMPOSE_LIST);
		$$->DecomposeList.DecomposeList = $1;
		$$->DecomposeList.Comma = &Comma;
		$$->DecomposeList.DecomposeSpec = $3;
	}
	| DecomposeSpec
	{
		$$ = make (DECOMPOSE_LIST);
		$$->DecomposeList.DecomposeSpec = $1;
	}
	;

DistributeList
	: DistributeList ',' DistributeSpec
	{
		$$ = make (DISTRIBUTE_LIST);
		$$->DistributeList.DistributeList = $1;
		$$->DistributeList.Comma = &Comma;
		$$->DistributeList.DistributeSpec = $3;
	}
	| DistributeSpec
	{
		$$ = make (DISTRIBUTE_LIST);
		$$->DistributeList.DistributeSpec = $1;
	}
	;

AlignStuff
	: NAME '(' SubscriptList ')' DIRWITH AlignSpec
	{
		$$ = make (ALIGN_STUFF);
		$$->AlignStuff.Name = $1;
		$$->AlignStuff.Lp = &Lp;
		$$->AlignStuff.SubscriptList = $3;
		$$->AlignStuff.Rp = &Rp;
		$$->AlignStuff.Dirwith = &Dirwith;
		$$->AlignStuff.AlignSpec = $6;
	}
	| '(' SubscriptList ')' DIRWITH AlignSpec ':' ':' AligneeList
	{
		$$ = make (ALIGN_STUFF);
		$$->AlignStuff.Lp = &Lp;
		$$->AlignStuff.SubscriptList = $2;
		$$->AlignStuff.Rp = &Rp;
		$$->AlignStuff.Dirwith = &Dirwith;
		$$->AlignStuff.AlignSpec = $5;
		$$->AlignStuff.Colon = &Colon;
		$$->AlignStuff.Colon1 = &Colon;
		$$->AlignStuff.AligneeList = $8;
	}
	| DIRWITH AlignSpec ':' ':' AligneeList
	{
		$$ = make (ALIGN_STUFF);
		$$->AlignStuff.Dirwith = &Dirwith;
		$$->AlignStuff.AlignSpec = $2;
		$$->AlignStuff.Colon = &Colon;
		$$->AlignStuff.Colon1 = &Colon;
		$$->AlignStuff.AligneeList = $5;
	}
	| NAME '(' DIRRANGE '(' NAME ')' ')' DIRWITH AlignSpec
	{
		$$ = make (ALIGN_STUFF);
		$$->AlignStuff.Name = $1;
		$$->AlignStuff.Lp = &Lp;
		$$->AlignStuff.Dirrange = &Dirrange;
		$$->AlignStuff.Lp1 = &Lp;
		$$->AlignStuff.Name1 = $5;
		$$->AlignStuff.Rp = &Rp;
		$$->AlignStuff.Rp1 = &Rp;
		$$->AlignStuff.Dirwith = &Dirwith;
		$$->AlignStuff.AlignSpec = $9;
	}
	;

OptCC
	:
	{
		$$ = (Node*) 0;
	}
	| ':' ':'
	{
		$$ = make (OPT_C_C);
		$$->OptCC.Colon = &Colon;
		$$->OptCC.Colon1 = &Colon;
	}
	;

ProcsDeclList
	: NAME '(' INTEGER_CONSTANT ',' INTEGER_CONSTANT ',' INTEGER_CONSTANT ')'
	{
		$$ = make (PROCS_DECL_LIST);
		$$->ProcsDeclList.Name = $1;
		$$->ProcsDeclList.Lp = &Lp;
		$$->ProcsDeclList.IntegerConstant = $3;
		$$->ProcsDeclList.Comma = &Comma;
		$$->ProcsDeclList.IntegerConstant1 = $5;
		$$->ProcsDeclList.Comma1 = &Comma;
		$$->ProcsDeclList.IntegerConstant2 = $7;
		$$->ProcsDeclList.Rp = &Rp;
	}
	| NAME '(' INTEGER_CONSTANT ',' INTEGER_CONSTANT ')'
	{
		$$ = make (PROCS_DECL_LIST);
		$$->ProcsDeclList.Name = $1;
		$$->ProcsDeclList.Lp = &Lp;
		$$->ProcsDeclList.IntegerConstant = $3;
		$$->ProcsDeclList.Comma = &Comma;
		$$->ProcsDeclList.IntegerConstant1 = $5;
		$$->ProcsDeclList.Rp = &Rp;
	}
	| NAME '(' INTEGER_CONSTANT ')'
	{
		$$ = make (PROCS_DECL_LIST);
		$$->ProcsDeclList.Name = $1;
		$$->ProcsDeclList.Lp = &Lp;
		$$->ProcsDeclList.IntegerConstant = $3;
		$$->ProcsDeclList.Rp = &Rp;
	}
	;

DecomposeSpec
	: NAME '(' SizeList ')'
	{
		$$ = make (DECOMPOSE_SPEC);
		$$->DecomposeSpec.Name = $1;
		$$->DecomposeSpec.Lp = &Lp;
		$$->DecomposeSpec.SizeList = $3;
		$$->DecomposeSpec.Rp = &Rp;
	}
	;

SizeList
	: SizeList ',' Size
	{
		$$ = make (SIZE_LIST);
		$$->SizeList.SizeList = $1;
		$$->SizeList.Comma = &Comma;
		$$->SizeList.Size = $3;
	}
	| Size
	{
		$$ = make (SIZE_LIST);
		$$->SizeList.Size = $1;
	}
	;

DistList
	: DistList ',' DistSpec
	{
		$$ = make (DIST_LIST);
		$$->DistList.DistList = $1;
		$$->DistList.Comma = &Comma;
		$$->DistList.DistSpec = $3;
	}
	| DistSpec
	{
		$$ = make (DIST_LIST);
		$$->DistList.DistSpec = $1;
	}
	;

SubscriptList
	: SubscriptList ',' Subscript
	{
		$$ = make (SUBSCRIPT_LIST);
		$$->SubscriptList.SubscriptList = $1;
		$$->SubscriptList.Comma = &Comma;
		$$->SubscriptList.Subscript = $3;
	}
	| Subscript
	{
		$$ = make (SUBSCRIPT_LIST);
		$$->SubscriptList.Subscript = $1;
	}
	;

AligneeList
	: AligneeList ',' NAME
	{
		$$ = make (ALIGNEE_LIST);
		$$->AligneeList.AligneeList = $1;
		$$->AligneeList.Comma = &Comma;
		$$->AligneeList.Name = $3;
	}
	| NAME
	{
		$$ = make (ALIGNEE_LIST);
		$$->AligneeList.Name = $1;
	}
	;

NameList
	: NameList ',' NAME
	{
		$$ = make (NAME_LIST);
		$$->NameList.NameList = $1;
		$$->NameList.Comma = &Comma;
		$$->NameList.Name = $3;
	}
	| NAME
	{
		$$ = make (NAME_LIST);
		$$->NameList.Name = $1;
	}
	;

LiteralConstant
	: INTEGER_CONSTANT
	| REAL_CONSTANT
	| ComplexLiteralConstant
	| LOGICAL_CONSTANT
	| BozLiteralConstant
	| CHARACTER_CONSTANT
	;

ComplexLiteralConstant
	: '(' Expr ',' Expr ')'
	{
		$$ = make (COMPLEX_LITERAL_CONSTANT);
		$$->ComplexLiteralConstant.Lp = &Lp;
		$$->ComplexLiteralConstant.Expr = $2;
		$$->ComplexLiteralConstant.Comma = &Comma;
		$$->ComplexLiteralConstant.Expr1 = $4;
		$$->ComplexLiteralConstant.Rp = &Rp;
	}
	;

BozLiteralConstant
	: BINARY_CONSTANT
	{
		$$ = &BinaryConstant;
	}
	| OCTAL_CONSTANT
	{
		$$ = &OctalConstant;
	}
	| HEX_CONSTANT
	{
		$$ = &HexConstant;
	}
	;

IntrinsicOp
	: POWER_OP
	{
		$$ = &PowerOp;
	}
	| MultOp
	| AddOp
	| CONCAT_OP
	{
		$$ = &ConcatOp;
	}
	| RelOp
	| NOT_OP
	{
		$$ = &NotOp;
	}
	| AND_OP
	{
		$$ = &AndOp;
	}
	| OR_OP
	{
		$$ = &OrOp;
	}
	| XOR_OP
	{
		$$ = &XorOp;
	}
	| EquivOp
	;

MultOp
	: '*'
	{
		$$ = &Times;
	}
	| '/'
	{
		$$ = &Slash;
	}
	;

AddOp
	: '+'
	{
		$$ = &Plus;
	}
	| '-'
	{
		$$ = &Minus;
	}
	;

RelOp
	: REL_OP_EQ
	{
		$$ = &RelOpEq;
	}
	| REL_OP_NE
	{
		$$ = &RelOpNe;
	}
	| REL_OP_LT
	{
		$$ = &RelOpLt;
	}
	| REL_OP_LE
	{
		$$ = &RelOpLe;
	}
	| REL_OP_GT
	{
		$$ = &RelOpGt;
	}
	| REL_OP_GE
	{
		$$ = &RelOpGe;
	}
	;

EquivOp
	: EQUIV_OP_T
	{
		$$ = &EquivOpT;
	}
	| EQUIV_OP_F
	{
		$$ = &EquivOpF;
	}
	;

DefinedOperator
	: DEFINED_UNARY_OP
	{
		f90ni_uddtao ();
	}

	| IntrinsicOp
	;

DerivedTypeStmt
	: TYPE ',' AccessSpec OptCC NAME
	{$$ = make (DERIVED_TYPE_STMT);}

	| TYPE NAME
	{$$ = make (DERIVED_TYPE_STMT);}

	;

OptPrivateSequenceStmtList
	:
	{
		$$ = (Node*) 0;
	}
	| PrivateSequenceStmtList
	{;}

	;

ComponentDefStmtList
	: ComponentDefStmt EOS
	{;}

	| ComponentDefStmtList ComponentDefStmt EOS
	{;}

	;

EndTypeStmt
	: END_TYPE
	{$$ = make (END_TYPE_STMT);}

	| END_TYPE NAME
	{$$ = make (END_TYPE_STMT);}

	;

PrivateSequenceStmtList
	: PrivateSequenceStmt EOS
	{;}

	| PrivateSequenceStmtList PrivateSequenceStmt EOS
	{;}

	;

PrivateSequenceStmt
	: PRIVATE
	{
		$$ = make (PRIVATE_SEQUENCE_STMT);
		$$->PrivateSequenceStmt.Private = &Private;
	}
	| SEQUENCE
	{
		$$ = make (PRIVATE_SEQUENCE_STMT);
		$$->PrivateSequenceStmt.Sequence = &Sequence;
	}
	;

ComponentDefStmt
	: TypeSpec ',' ComponentAttrSpecList ':' ':' ComponentDeclList
	{$$ = make (COMPONENT_DEF_STMT);}

	| TypeSpec ':' ':' ComponentDeclList
	{$$ = make (COMPONENT_DEF_STMT);}

	| TypeSpec ComponentDeclList
	{$$ = make (COMPONENT_DEF_STMT);}

	;

AccessSpec
	: PUBLIC
	{;}

	| PRIVATE
	{;}

	;

TypeSpec
	: INTEGER OptKindSelector
	{
		$$ = make (TYPE_SPEC);
		$$->TypeSpec.Integer = &Integer;
		$$->TypeSpec.OptKindSelector = $2;
	{
		$$ = parse_TypeSpec ($$, "INTEGER", TYP_INTEGER, 0);
	}
	}
	| REAL OptKindSelector
	{
		$$ = make (TYPE_SPEC);
		$$->TypeSpec.Real = &Real;
		$$->TypeSpec.OptKindSelector = $2;
	{
		$$ = parse_TypeSpec ($$, "REAL", TYP_REAL, 0);
	}
	}
	| DOUBLE_PRECISION
	{
		$$ = make (TYPE_SPEC);
		$$->TypeSpec.DoublePrecision = &DoublePrecision;
	{
		$$ = parse_TypeSpec ($$, "DOUBLE PRECISION", TYP_REAL, 1);
	}
	}
	| COMPLEX OptKindSelector
	{
		$$ = make (TYPE_SPEC);
		$$->TypeSpec.Complex = &Complex;
		$$->TypeSpec.OptKindSelector = $2;
	{
		$$ = parse_TypeSpec ($$, "COMPLEX", TYP_COMPLEX, 0);
	}
	}
	| DOUBLE_COMPLEX OptKindSelector
	{
		$$ = make (TYPE_SPEC);
		$$->TypeSpec.DoubleComplex = &DoubleComplex;
		$$->TypeSpec.OptKindSelector = $2;
	{
		$$ = parse_TypeSpec ($$, "DOUBLE COMPLEX", TYP_COMPLEX, 1);
	}
	}
	| CHARACTER
	{
		$$ = make (TYPE_SPEC);
		$$->TypeSpec.Character = &Character;
	{
		se_EtypeSpec = machine_etype (TYP_CHARACTER, 0);
	}
	}
	| CHARACTER CharSelector
	{
		$$ = make (TYPE_SPEC);
		$$->TypeSpec.Character = &Character;
		$$->TypeSpec.CharSelector = $2;
	{
		se_EtypeSpec = machine_etype (TYP_CHARACTER, 0);
	}
	}
	| LOGICAL OptKindSelector
	{
		$$ = make (TYPE_SPEC);
		$$->TypeSpec.Logical = &Logical;
		$$->TypeSpec.OptKindSelector = $2;
	{
		$$ = parse_TypeSpec ($$, "LOGICAL", TYP_LOGICAL, 0);
	}
	}
	| TYPE '(' NAME ')'
	{
		f90ni_UDDTAO;
	}

	;

ComponentAttrSpecList
	: ComponentAttrSpecList ',' ComponentAttrSpec
	{;}

	| ComponentAttrSpec
	{;}

	;

ComponentDeclList
	: ComponentDeclList ',' ComponentDecl
	{;}

	| ComponentDecl
	{;}

	;

ComponentDecl
	: NAME '(' SubscriptList ')' '*' CharLength
	{;}

	| NAME
	{;}

	| NAME '(' SubscriptList ')'
	{;}

	| NAME '*' CharLength
	{;}

	;

ComponentAttrSpec
	: POINTER
	{;}

	| DIMENSION '(' SubscriptList ')'
	{;}

	;

CharLength
	: '(' TypeParamValue ')'
	{
		$$ = make (CHAR_LENGTH);
		$$->CharLength.Lp = &Lp;
		$$->CharLength.TypeParamValue = $2;
		$$->CharLength.Rp = &Rp;
	}
	| LiteralConstant
	{
		$$ = make (CHAR_LENGTH);
		$$->CharLength.LiteralConstant = $1;
	}
	;

ArrayConstructor
	: LDAC AcValueList RDAC
	{
		$$ = make (ARRAY_CONSTRUCTOR);
		$$->ArrayConstructor.Ldac = &Ldac;
		$$->ArrayConstructor.AcValueList = $2;
		$$->ArrayConstructor.Rdac = &Rdac;
	}
	;

AcValueList
	: ImpliedValueList
	;

ImpliedValueList
	: ImpliedValueList ',' ImpliedValue
	{
		$$ = make (IMPLIED_VALUE_LIST);
		$$->ImpliedValueList.ImpliedValueList = $1;
		$$->ImpliedValueList.Comma = &Comma;
		$$->ImpliedValueList.ImpliedValue = $3;
	}
	| ImpliedValue
	{
		$$ = make (IMPLIED_VALUE_LIST);
		$$->ImpliedValueList.ImpliedValue = $1;
	}
	;

ImpliedValue
	: Expr
	| ImpliedDo
	| Stride
	;

ImpliedDo
	: LPEQI ImpliedValueList ',' ImpliedDoControl ')'
	{
		$$ = make (IMPLIED_DO);
		$$->ImpliedDo.Lpeqi = &Lpeqi;
		$$->ImpliedDo.ImpliedValueList = $2;
		$$->ImpliedDo.Comma = &Comma;
		$$->ImpliedDo.ImpliedDoControl = $4;
		$$->ImpliedDo.Rp = &Rp;
	}
	;

Stride
	: Expr ':' Expr
	{
		$$ = make (STRIDE);
		$$->Stride.Expr = $1;
		$$->Stride.Colon = &Colon;
		$$->Stride.Expr1 = $3;
	}
	| Expr ':' Expr ':' Expr
	{
		$$ = make (STRIDE);
		$$->Stride.Expr = $1;
		$$->Stride.Colon = &Colon;
		$$->Stride.Expr1 = $3;
		$$->Stride.Colon1 = &Colon;
		$$->Stride.Expr2 = $5;
	}
	;

ImpliedDoControl
	: NAME '=' Expr ',' Expr ',' Expr
	{
		$$ = make (IMPLIED_DO_CONTROL);
		$$->ImpliedDoControl.Name = $1;
		$$->ImpliedDoControl.Eq = &Eq;
		$$->ImpliedDoControl.Expr = $3;
		$$->ImpliedDoControl.Comma = &Comma;
		$$->ImpliedDoControl.Expr1 = $5;
		$$->ImpliedDoControl.Comma1 = &Comma;
		$$->ImpliedDoControl.Expr2 = $7;
	}
	| NAME '=' Expr ',' Expr
	{
		$$ = make (IMPLIED_DO_CONTROL);
		$$->ImpliedDoControl.Name = $1;
		$$->ImpliedDoControl.Eq = &Eq;
		$$->ImpliedDoControl.Expr = $3;
		$$->ImpliedDoControl.Comma = &Comma;
		$$->ImpliedDoControl.Expr1 = $5;
	}
	;

OptComma
	:
	{
		$$ = (Node*) 0;
	}
	| ','
	{
		$$ = &Comma;
	}
	;

AttrSpecList
	: AttrSpecList ',' AttrSpec
	{
		$$ = make (ATTR_SPEC_LIST);
		$$->AttrSpecList.AttrSpecList = $1;
		$$->AttrSpecList.Comma = &Comma;
		$$->AttrSpecList.AttrSpec = $3;
	}
	| AttrSpec
	{
		$$ = make (ATTR_SPEC_LIST);
		$$->AttrSpecList.AttrSpec = $1;
	}
	;

EntityDecl1List
	: EntityDecl1List ',' EntityDecl1
	{
		$$ = make (ENTITY_DECL_1_LIST);
		$$->EntityDecl1List.EntityDecl1List = $1;
		$$->EntityDecl1List.Comma = &Comma;
		$$->EntityDecl1List.EntityDecl1 = $3;
	}
	| EntityDecl1
	{
		$$ = make (ENTITY_DECL_1_LIST);
		$$->EntityDecl1List.EntityDecl1 = $1;
	}
	;

EntityDeclList
	: EntityDeclList ',' EntityDecl
	{
		$$ = make (ENTITY_DECL_LIST);
		$$->EntityDeclList.EntityDeclList = $1;
		$$->EntityDeclList.Comma = &Comma;
		$$->EntityDeclList.EntityDecl = $3;
	}
	| EntityDecl
	{
		$$ = make (ENTITY_DECL_LIST);
		$$->EntityDeclList.EntityDecl = $1;
	}
	;

EntityDecl
	: NAME opt7
	{
		$$ = make (ENTITY_DECL);
		$$->EntityDecl.Name = $1;
		$$->EntityDecl.opt7 = $2;
	}
	;

EntityDecl1
	: EntityDecl OptCharLength OptInitializationExpr
	{
		$$ = make (ENTITY_DECL_1);
		$$->EntityDecl1.EntityDecl = $1;
		$$->EntityDecl1.OptCharLength = $2;
		$$->EntityDecl1.OptInitializationExpr = $3;
	}
	;

AttrSpec
	: NAME
	{
		$$ = make (ATTR_SPEC);
		$$->AttrSpec.Name = $1;
	{
		yacc_AttrSpec ($$);
	}
	}
	| NAME '(' SubscriptList ')'
	{
		$$ = make (ATTR_SPEC);
		$$->AttrSpec.Name = $1;
		$$->AttrSpec.Lp = &Lp;
		$$->AttrSpec.SubscriptList = $3;
		$$->AttrSpec.Rp = &Rp;
	{
		yacc_AttrSpec ($$);
	}
	}
	;

OptKindSelector
	:
	{
		$$ = (Node*) 0;
	}
	| KindSelector
	;

CharSelector
	: '(' NAME '=' Expr ',' NAME '=' Expr ')'
	{
		$$ = make (CHAR_SELECTOR);
		$$->CharSelector.Lp = &Lp;
		$$->CharSelector.Name = $2;
		$$->CharSelector.Eq = &Eq;
		$$->CharSelector.Expr = $4;
		$$->CharSelector.Comma = &Comma;
		$$->CharSelector.Name1 = $6;
		$$->CharSelector.Eq1 = &Eq;
		$$->CharSelector.Expr1 = $8;
		$$->CharSelector.Rp = &Rp;
	{
		$$ = yacc_CharSelector_2 ($$);
	}
	}
	| '(' NAME '=' Expr ')'
	{
		$$ = make (CHAR_SELECTOR);
		$$->CharSelector.Lp = &Lp;
		$$->CharSelector.Name = $2;
		$$->CharSelector.Eq = &Eq;
		$$->CharSelector.Expr = $4;
		$$->CharSelector.Rp = &Rp;
	{
		$$ = yacc_CharSelector_1 ($$);
	}
	}
	| '*' CharLength
	{
		$$ = make (CHAR_SELECTOR);
		$$->CharSelector.Times = &Times;
		$$->CharSelector.CharLength = $2;
	}
	| '*' CharLength CHAR_SELECTOR_COMMA
	{
		$$ = make (CHAR_SELECTOR);
		$$->CharSelector.Times = &Times;
		$$->CharSelector.CharLength = $2;
		$$->CharSelector.CharSelectorComma = &CharSelectorComma;
	}
	| '(' Expr ')'
	{
		$$ = make (CHAR_SELECTOR);
		$$->CharSelector.Lp = &Lp;
		$$->CharSelector.Expr = $2;
		$$->CharSelector.Rp = &Rp;
	}
	| LPEQI NAME '=' Expr ',' NAME '=' Expr ')'
	{
		$$ = make (CHAR_SELECTOR);
		$$->CharSelector.Lpeqi = &Lpeqi;
		$$->CharSelector.Name = $2;
		$$->CharSelector.Eq = &Eq;
		$$->CharSelector.Expr = $4;
		$$->CharSelector.Comma = &Comma;
		$$->CharSelector.Name1 = $6;
		$$->CharSelector.Eq1 = &Eq;
		$$->CharSelector.Expr1 = $8;
		$$->CharSelector.Rp = &Rp;
	{
		$$ = yacc_CharSelector_2 ($$);
	}
	}
	| LPEQI NAME '=' Expr ')'
	{
		$$ = make (CHAR_SELECTOR);
		$$->CharSelector.Lpeqi = &Lpeqi;
		$$->CharSelector.Name = $2;
		$$->CharSelector.Eq = &Eq;
		$$->CharSelector.Expr = $4;
		$$->CharSelector.Rp = &Rp;
	{
		$$ = yacc_CharSelector_1 ($$);
	}
	}
	;

OptCharLength
	:
	{
		$$ = (Node*) 0;
	}
	| '*' CharLength
	{
		$$ = make (OPT_CHAR_LENGTH);
		$$->OptCharLength.Times = &Times;
		$$->OptCharLength.CharLength = $2;
	}
	;

OptInitializationExpr
	:
	{
		$$ = (Node*) 0;
	}
	| '=' Expr
	{
		$$ = make (OPT_INITIALIZATION_EXPR);
		$$->OptInitializationExpr.Eq = &Eq;
		$$->OptInitializationExpr.Expr = $2;
	}
	;

opt7
	:
	{
		$$ = (Node*) 0;
	}
	| '(' SubscriptList ')'
	{
		$$ = make (OPT_7);
		$$->opt7.Lp = &Lp;
		$$->opt7.SubscriptList = $2;
		$$->opt7.Rp = &Rp;
	}
	;

KindSelector
	: '(' NAME '=' Expr ')'
	{
		$$ = make (KIND_SELECTOR);
		$$->KindSelector.Lp = &Lp;
		$$->KindSelector.Name = $2;
		$$->KindSelector.Eq = &Eq;
		$$->KindSelector.Expr = $4;
		$$->KindSelector.Rp = &Rp;
	}
	| '(' Expr ')'
	{
		$$ = make (KIND_SELECTOR);
		$$->KindSelector.Lp = &Lp;
		$$->KindSelector.Expr = $2;
		$$->KindSelector.Rp = &Rp;
	}
	| '*' INTEGER_CONSTANT
	{
		$$ = make (KIND_SELECTOR);
		$$->KindSelector.Times = &Times;
		$$->KindSelector.IntegerConstant = $2;
	}
	| LPEQI NAME '=' Expr ')'
	{
		$$ = make (KIND_SELECTOR);
		$$->KindSelector.Lpeqi = &Lpeqi;
		$$->KindSelector.Name = $2;
		$$->KindSelector.Eq = &Eq;
		$$->KindSelector.Expr = $4;
		$$->KindSelector.Rp = &Rp;
	}
	;

TypeParamValue
	: Expr
	| '*'
	{
		$$ = &Times;
	}
	;

SavedEntityList
	: SavedEntityList ',' SavedEntity
	{
		$$ = make (SAVED_ENTITY_LIST);
		$$->SavedEntityList.SavedEntityList = $1;
		$$->SavedEntityList.Comma = &Comma;
		$$->SavedEntityList.SavedEntity = $3;
	}
	| SavedEntity
	{
		$$ = make (SAVED_ENTITY_LIST);
		$$->SavedEntityList.SavedEntity = $1;
	}
	;

SavedEntity
	: '/' NAME '/'
	{
		$$ = make (SAVED_ENTITY);
		$$->SavedEntity.Slash = &Slash;
		$$->SavedEntity.Name = $2;
		$$->SavedEntity.Slash1 = &Slash;
	}
	| NAME
	{
		$$ = make (SAVED_ENTITY);
		$$->SavedEntity.Name = $1;
	}
	;

EntityAllocatableList
	: EntityAllocatableList ',' EntityAllocatable
	{;}

	| EntityAllocatable
	{;}

	;

EntityAllocatable
	: NAME '(' SubscriptList ')'
	{;}

	| NAME
	{;}

	;

EntityTargetList
	: EntityTargetList ',' EntityTarget
	{;}

	| EntityTarget
	{;}

	;

EntityTarget
	: NAME '(' SubscriptList ')'
	{;}

	| NAME
	{;}

	;

DataStmtSetList
	: DataStmtSetList ',' DataStmtSet
	{
		$$ = make (DATA_STMT_SET_LIST);
		$$->DataStmtSetList.DataStmtSetList = $1;
		$$->DataStmtSetList.Comma = &Comma;
		$$->DataStmtSetList.DataStmtSet = $3;
	}
	| DataStmtSetList DataStmtSet
	{
		$$ = make (DATA_STMT_SET_LIST);
		$$->DataStmtSetList.DataStmtSetList = $1;
		$$->DataStmtSetList.DataStmtSet = $2;
	}
	| DataStmtSet
	{
		$$ = make (DATA_STMT_SET_LIST);
		$$->DataStmtSetList.DataStmtSet = $1;
	}
	;

DataStmtSet
	: DataStmtObjectList '/' DataStmtValueList '/'
	{
		$$ = make (DATA_STMT_SET);
		$$->DataStmtSet.DataStmtObjectList = $1;
		$$->DataStmtSet.Slash = &Slash;
		$$->DataStmtSet.DataStmtValueList = $3;
		$$->DataStmtSet.Slash1 = &Slash;
	}
	;

DataStmtObjectList
	: DataStmtObjectList ',' DataStmtObject
	{
		$$ = make (DATA_STMT_OBJECT_LIST);
		$$->DataStmtObjectList.DataStmtObjectList = $1;
		$$->DataStmtObjectList.Comma = &Comma;
		$$->DataStmtObjectList.DataStmtObject = $3;
	}
	| DataStmtObject
	{
		$$ = make (DATA_STMT_OBJECT_LIST);
		$$->DataStmtObjectList.DataStmtObject = $1;
	}
	;

DataStmtValueList
	: DataStmtValueList ',' DataStmtValue
	{
		$$ = make (DATA_STMT_VALUE_LIST);
		$$->DataStmtValueList.DataStmtValueList = $1;
		$$->DataStmtValueList.Comma = &Comma;
		$$->DataStmtValueList.DataStmtValue = $3;
	}
	| DataStmtValue
	{
		$$ = make (DATA_STMT_VALUE_LIST);
		$$->DataStmtValueList.DataStmtValue = $1;
	}
	;

DataStmtObject
	: Variable
	| DataImpliedDo
	;

DataStmtValue
	: DataStmtRepeat '*' DataStmtConstant
	{
		$$ = make (DATA_STMT_VALUE);
		$$->DataStmtValue.DataStmtRepeat = $1;
		$$->DataStmtValue.Times = &Times;
		$$->DataStmtValue.DataStmtConstant = $3;
	}
	| DataStmtConstant
	{
		$$ = make (DATA_STMT_VALUE);
		$$->DataStmtValue.DataStmtConstant = $1;
	}
	;

Variable
	: NAME
	{
		$$ = make (VARIABLE);
		$$->Variable.Name = $1;
	}
	| ArraySection
	{
		$$ = $1;
	}

	| StructureComponent
	{
		f90ni_uddtao ();
	}

	;

DataImpliedDo
	: ImpliedDo
	;

DataStmtRepeat
	: NAME
	| LiteralConstant
	;

DataStmtConstant
	: AddOp DataStmtRepeat
	{
		$$ = make (DATA_STMT_CONSTANT);
		$$->DataStmtConstant.AddOp = $1;
		$$->DataStmtConstant.DataStmtRepeat = $2;
	}
	| DataStmtRepeat
	{
		$$ = make (DATA_STMT_CONSTANT);
		$$->DataStmtConstant.DataStmtRepeat = $1;
	}
	| ArraySection
	{
		$$ = make (DATA_STMT_CONSTANT);
		$$->DataStmtConstant.ArraySection = $1;
	}
	;

ArraySection
	: NAME '(' SubscriptList ')'
	{
		$$ = make (ARRAY_SECTION);
		$$->ArraySection.Name = $1;
		$$->ArraySection.Lp = &Lp;
		$$->ArraySection.SubscriptList = $3;
		$$->ArraySection.Rp = &Rp;
	}
	| NAME '(' Org_SubscriptList
	{
		$$ = make (ARRAY_SECTION);
		$$->ArraySection.Name = $1;
		$$->ArraySection.Lp = &Lp;
		$$->ArraySection.Org_SubscriptList = $3;
	}
	| NAME LPEQI SubscriptList ')'
	{
		$$ = make (ARRAY_SECTION);
		$$->ArraySection.Name = $1;
		$$->ArraySection.Lpeqi = &Lpeqi;
		$$->ArraySection.SubscriptList = $3;
		$$->ArraySection.Rp = &Rp;
	{
		$$->ArraySection.Lp = &Lp;
		$$->ArraySection.Lpeqi = NN;
	}
	}
	| ArraySection '(' SubscriptList ')'
	{
		$$ = make (ARRAY_SECTION);
		$$->ArraySection.ArraySection = $1;
		$$->ArraySection.Lp = &Lp;
		$$->ArraySection.SubscriptList = $3;
		$$->ArraySection.Rp = &Rp;
	}
	| StructureComponent '(' SubscriptList ')'
	{;}

	| CHARACTER_CONSTANT '(' SubscriptList ')'
	{
		$$ = make (ARRAY_SECTION);
		$$->ArraySection.CharacterConstant = $1;
		$$->ArraySection.Lp = &Lp;
		$$->ArraySection.SubscriptList = $3;
		$$->ArraySection.Rp = &Rp;
	}
	| NAME '(' ')'
	{
		$$ = make (ARRAY_SECTION);
		$$->ArraySection.Name = $1;
		$$->ArraySection.Lp = &Lp;
		$$->ArraySection.Rp = &Rp;
	}
	;

NamedConstantDefList
	: NamedConstantDefList ',' NamedConstantDef
	{
		$$ = make (NAMED_CONSTANT_DEF_LIST);
		$$->NamedConstantDefList.NamedConstantDefList = $1;
		$$->NamedConstantDefList.Comma = &Comma;
		$$->NamedConstantDefList.NamedConstantDef = $3;
	}
	| NamedConstantDef
	{
		$$ = make (NAMED_CONSTANT_DEF_LIST);
		$$->NamedConstantDefList.NamedConstantDef = $1;
	}
	;

NamedConstantDef
	: NAME '=' Expr
	{
		$$ = make (NAMED_CONSTANT_DEF);
		$$->NamedConstantDef.Name = $1;
		$$->NamedConstantDef.Eq = &Eq;
		$$->NamedConstantDef.Expr = $3;
	}
	;

ImplicitSpecList
	: ImplicitSpecList ',' ImplicitSpec
	{
		$$ = make (IMPLICIT_SPEC_LIST);
		$$->ImplicitSpecList.ImplicitSpecList = $1;
		$$->ImplicitSpecList.Comma = &Comma;
		$$->ImplicitSpecList.ImplicitSpec = $3;
	}
	| ImplicitSpec
	{
		$$ = make (IMPLICIT_SPEC_LIST);
		$$->ImplicitSpecList.ImplicitSpec = $1;
	}
	;

ImplicitSpec
	: TypeSpec LPIMP LetterSpecList ')'
	{
		$$ = make (IMPLICIT_SPEC);
		$$->ImplicitSpec.TypeSpec = $1;
		$$->ImplicitSpec.Lpimp = &Lpimp;
		$$->ImplicitSpec.LetterSpecList = $3;
		$$->ImplicitSpec.Rp = &Rp;
	}
	;

LetterSpecList
	: LetterSpecList ',' LetterSpec
	{
		$$ = make (LETTER_SPEC_LIST);
		$$->LetterSpecList.LetterSpecList = $1;
		$$->LetterSpecList.Comma = &Comma;
		$$->LetterSpecList.LetterSpec = $3;
	}
	| LetterSpec
	{
		$$ = make (LETTER_SPEC_LIST);
		$$->LetterSpecList.LetterSpec = $1;
	}
	;

LetterSpec
	: Letter '-' Letter
	{
		$$ = make (LETTER_SPEC);
		$$->LetterSpec.Letter = $1;
		$$->LetterSpec.Minus = &Minus;
		$$->LetterSpec.Letter1 = $3;
	{
		implicit_set ($1->com.str[0], $3->com.str[0], se_EtypeSpec);
	}
	}
	| Letter
	{
		$$ = make (LETTER_SPEC);
		$$->LetterSpec.Letter = $1;
	{
		implicit_set ($1->com.str[0], $1->com.str[0], se_EtypeSpec);
	}
	}
	;

Letter
	: NAME	{
		if (strlen ($1->com.str) != 1)
			yyerror ("syntax error");
	}

	;

EquivalenceSetList
	: EquivalenceSetList ',' EquivalenceSet
	{
		$$ = make (EQUIVALENCE_SET_LIST);
		$$->EquivalenceSetList.EquivalenceSetList = $1;
		$$->EquivalenceSetList.Comma = &Comma;
		$$->EquivalenceSetList.EquivalenceSet = $3;
	}
	| EquivalenceSet
	{
		$$ = make (EQUIVALENCE_SET_LIST);
		$$->EquivalenceSetList.EquivalenceSet = $1;
	}
	;

EquivalenceSet
	: '(' EquivalenceObjectList ')'
	{
		$$ = make (EQUIVALENCE_SET);
		$$->EquivalenceSet.Lp = &Lp;
		$$->EquivalenceSet.EquivalenceObjectList = $2;
		$$->EquivalenceSet.Rp = &Rp;
	}
	;

EquivalenceObjectList
	: EquivalenceObjectList ',' EquivalenceObject
	{
		$$ = make (EQUIVALENCE_OBJECT_LIST);
		$$->EquivalenceObjectList.EquivalenceObjectList = $1;
		$$->EquivalenceObjectList.Comma = &Comma;
		$$->EquivalenceObjectList.EquivalenceObject = $3;
	}
	| EquivalenceObject
	{
		$$ = make (EQUIVALENCE_OBJECT_LIST);
		$$->EquivalenceObjectList.EquivalenceObject = $1;
	}
	;

EquivalenceObject
	: NAME
	| ArraySection
	;

CommonStmt1
	: COMMON
	{
		se_CommonStmt_in = 1;
	}
	 CommonBlock EntityDecl
	{
		$$ = make (COMMON_STMT_1);
		$$->CommonStmt1.Common = &Common;
		$$->CommonStmt1.CommonBlock = $3;
		$$->CommonStmt1.EntityDecl = $4;
	}
	| COMMON
	{
		se_CommonStmt_in = 1;
	}
	 EntityDecl
	{
		$$ = make (COMMON_STMT_1);
		$$->CommonStmt1.Common = &Common;
		$$->CommonStmt1.EntityDecl = $3;
	}
	;

CommonBlock
	: CONCAT_OP
	{
		$$ = make (COMMON_BLOCK);
		$$->CommonBlock.ConcatOp = &ConcatOp;
	{
		se_CommonStmt_blank = 1;
	}
	}
	| '/' NAME '/'
	{
		$$ = make (COMMON_BLOCK);
		$$->CommonBlock.Slash = &Slash;
		$$->CommonBlock.Name = $2;
		$$->CommonBlock.Slash1 = &Slash;
	{
		T_Entry *entry;

		if (lookup_glo ($2->com.str) == TN) {
			entry = install_glo ($2->com.str, TAB_NAME, 0);
			SET_common (entry);
		}

		se_CommonStmt_blank = 0;
	}
	}
	;

StructureComponent
	: ParentStructure '%' NAME
	{
		;
	}

	;

ParentStructure
	: NAME
	| ArraySection
	| StructureComponent
	{
		;
	}

	;

Org_SubscriptList
	: Org_SubscriptList ',' Subscript
	{
		$$ = make (ORG___SUBSCRIPT_LIST);
		$$->Org_SubscriptList.Org_SubscriptList = $1;
		$$->Org_SubscriptList.Comma = &Comma;
		$$->Org_SubscriptList.Subscript = $3;
	}
	| Subscript
	{
		$$ = make (ORG___SUBSCRIPT_LIST);
		$$->Org_SubscriptList.Subscript = $1;
	}
	;

Subscript
	: Expr ':' Expr ':' Expr
	{
		$$ = make (SUBSCRIPT);
		$$->Subscript.Expr = $1;
		$$->Subscript.Colon = &Colon;
		$$->Subscript.Expr1 = $3;
		$$->Subscript.Colon1 = &Colon;
		$$->Subscript.Expr2 = $5;
	}
	| Expr
	{
		$$ = make (SUBSCRIPT);
		$$->Subscript.Expr = $1;
	}
	| '*'
	{
		$$ = make (SUBSCRIPT);
		$$->Subscript.Times = &Times;
	}
	| Expr ':' '*'
	{
		$$ = make (SUBSCRIPT);
		$$->Subscript.Expr = $1;
		$$->Subscript.Colon = &Colon;
		$$->Subscript.Times = &Times;
	}
	| ':'
	{
		$$ = make (SUBSCRIPT);
		$$->Subscript.Colon = &Colon;
	}
	| Expr ':'
	{
		$$ = make (SUBSCRIPT);
		$$->Subscript.Expr = $1;
		$$->Subscript.Colon = &Colon;
	}
	| ':' Expr
	{
		$$ = make (SUBSCRIPT);
		$$->Subscript.Colon = &Colon;
		$$->Subscript.Expr1 = $2;
	}

	| ':' ':' Expr
	{
		$$ = make (SUBSCRIPT);
		$$->Subscript.Colon = &Colon;
		$$->Subscript.Colon1 = &Colon;
		$$->Subscript.Expr2 = $3;
	}

	| Expr ':' Expr
	{
		$$ = make (SUBSCRIPT);
		$$->Subscript.Expr = $1;
		$$->Subscript.Colon = &Colon;
		$$->Subscript.Expr1 = $3;
	}
	| Expr ':' ':' Expr
	{
		$$ = make (SUBSCRIPT);
		$$->Subscript.Expr = $1;
		$$->Subscript.Colon = &Colon;
		$$->Subscript.Colon1 = &Colon;
		$$->Subscript.Expr2 = $4;
	}

	| ':' Expr ':' Expr
	{
		$$ = make (SUBSCRIPT);
		$$->Subscript.Colon = &Colon;
		$$->Subscript.Expr1 = $2;
		$$->Subscript.Colon1 = &Colon;
		$$->Subscript.Expr2 = $4;
	}

	| NAME '=' Expr
	{
		$$ = make (SUBSCRIPT);
		$$->Subscript.Name = $1;
		$$->Subscript.Eq = &Eq;
		$$->Subscript.Expr = $3;
	}
	| '*' Label
	{
		$$ = make (SUBSCRIPT);
		$$->Subscript.Times = &Times;
		$$->Subscript.Label = $2;
	}
	;

Label
	: INTEGER_CONSTANT	{
		label_install_ref ($1);
	}

	;

AllocationList
	: AllocationList ',' Allocation
	{;}

	| Allocation
	{;}

	;

Allocation
	: ArraySection
	{;}

	| NAME
	{;}

	| StructureComponent
	{;}

	;

AllocateObject
	: NAME
	{;}

	| StructureComponent
	{;}

	;

AllocateObjectList
	: AllocateObjectList ',' AllocateObject
	{;}

	| AllocateObject
	{;}

	;

Primary
	: LiteralConstant
	{
		$$ = $1;
	}

	| Variable
	{
		$$ = $1;
	}

	| ArrayConstructor
	{
		$$ = $1;
	}

	| '(' Expr ')'
	{
		$$ = make (PRIMARY);
		$$->Primary.Lp = &Lp;
		$$->Primary.Expr = $2;
		$$->Primary.Rp = &Rp;
	}
	| LPEQI Expr ')'
	{
		$$ = make (PRIMARY);
		$$->Primary.Lpeqi = &Lpeqi;
		$$->Primary.Expr = $2;
		$$->Primary.Rp = &Rp;
	{
		$$->Primary.Lp = &Lp;
		$$->Primary.Lpeqi = NN;
	}
	}
	;

Level1Expr
	: DEFINED_UNARY_OP Primary
	{
		f90ni_uddtao ();
	}

	| Primary
	{
		$$ = $1;
	}

	| AddOp Primary
	{
		$$ = make_DumExpr (NN, $1, $2);
	}

	;

MultOperand
	: Level1Expr POWER_OP MultOperand
	{
		$$ = make_DumExpr ($1, &PowerOp, $3);
	}

	| Level1Expr
	{
		$$ = $1;
	}

	;

AddOperand
	: AddOperand MultOp MultOperand
	{
		$$ = make_DumExpr ($1, $2, $3);
	}

	| MultOperand
	{
		$$ = $1;
	}

	;

Level2Expr
	: Level2Expr AddOp AddOperand
	{
		$$ = make_DumExpr ($1, $2, $3);
	}

	| AddOp AddOperand
	{
		$$ = make_DumExpr (NN, $1, $2);
	}

	| AddOperand
	{
		$$ = $1;
	}

	;

Level3Expr
	: Level3Expr CONCAT_OP Level2Expr
	{
		$$ = make_DumExpr ($1, &ConcatOp, $3);
	}

	| Level2Expr
	{
		$$ = $1;
	}

	;

Level4Expr
	: Level3Expr RelOp Level3Expr
	{
		$$ = make_DumExpr ($1, $2, $3);
	}

	| Level3Expr
	{
		$$ = $1;
	}

	;

AndOperand
	: NOT_OP Level4Expr
	{
		$$ = make_DumExpr (NN, &NotOp, $2);
	}

	| Level4Expr
	{
		$$ = $1;
	}

	;

OrOperand
	: OrOperand AND_OP AndOperand
	{
		$$ = make_DumExpr ($1, &AndOp, $3);
	}

	| AndOperand
	{
		$$ = $1;
	}

	;

EquivOperand
	: EquivOperand OR_OP OrOperand
	{
		$$ = make_DumExpr ($1, &OrOp, $3);
	}

	| EquivOperand XOR_OP OrOperand
	{
		$$ = make_DumExpr ($1, &XorOp, $3);
	}

	| OrOperand
	{
		$$ = $1;
	}

	;

Level5Expr
	: Level5Expr EquivOp EquivOperand
	{
		$$ = make_DumExpr ($1, $2, $3);
	}

	| EquivOperand
	{
		$$ = $1;
	}

	;

Target
	: ArraySection
	{;}

	| NAME
	{;}

	| StructureComponent
	{;}

	;

CaseSelector
	: '(' SubscriptList ')'
	{
		$$ = make (CASE_SELECTOR);
		$$->CaseSelector.Lp = &Lp;
		$$->CaseSelector.SubscriptList = $2;
		$$->CaseSelector.Rp = &Rp;
	}
	| NAME
	{
		$$ = make (CASE_SELECTOR);
		$$->CaseSelector.Name = $1;
	}
	;

OptLabel
	:
	{
		$$ = (Node*) 0;
	}
	| Label
	;

LoopControl
	:
	{
		$$ = (Node*) 0;
	}
	| OptComma ImpliedDoControl
	{
		$$ = make (LOOP_CONTROL);
		$$->LoopControl.OptComma = $1;
		$$->LoopControl.ImpliedDoControl = $2;
	}
	| OptComma NAME '(' Expr ')'
	{
		$$ = make (LOOP_CONTROL);
		$$->LoopControl.OptComma = $1;
		$$->LoopControl.Name = $2;
		$$->LoopControl.Lp = &Lp;
		$$->LoopControl.Expr = $4;
		$$->LoopControl.Rp = &Rp;
	{
		key_check ($2, "WHILE");
	}
	}
	| OptComma NAME LPEQI Expr ')'
	{
		$$ = make (LOOP_CONTROL);
		$$->LoopControl.OptComma = $1;
		$$->LoopControl.Name = $2;
		$$->LoopControl.Lpeqi = &Lpeqi;
		$$->LoopControl.Expr = $4;
		$$->LoopControl.Rp = &Rp;
	{
		key_check ($2, "WHILE");

		$$->LoopControl.Lpeqi = NN;
		$$->LoopControl.Lp = &Lp;
	}
	}
	| '(' Expr ')' NAME
	{
		$$ = make (LOOP_CONTROL);
		$$->LoopControl.Lp = &Lp;
		$$->LoopControl.Expr = $2;
		$$->LoopControl.Rp = &Rp;
		$$->LoopControl.Name = $4;
	{
		key_check ($4, "TIMES");  /*!!! replace by found NAME, expecting "TIMES" */
	}
	}
	| LPEQI Expr ')' NAME
	{
		$$ = make (LOOP_CONTROL);
		$$->LoopControl.Lpeqi = &Lpeqi;
		$$->LoopControl.Expr = $2;
		$$->LoopControl.Rp = &Rp;
		$$->LoopControl.Name = $4;
	{
		key_check ($4, "TIMES");

		$$->LoopControl.Lpeqi = NN;
		$$->LoopControl.Lp = &Lp;
	}
	}
	;

LabelList
	: LabelList ',' Label
	{
		$$ = make (LABEL_LIST);
		$$->LabelList.LabelList = $1;
		$$->LabelList.Comma = &Comma;
		$$->LabelList.Label = $3;
	}
	| Label
	{
		$$ = make (LABEL_LIST);
		$$->LabelList.Label = $1;
	}
	;

StopCode
	: CHARACTER_CONSTANT
	| INTEGER_CONSTANT
	;

ForallTripletSpec
	: NAME '=' Expr ':' Expr
	{
		$$ = make (FORALL_TRIPLET_SPEC);
		$$->ForallTripletSpec.Name = $1;
		$$->ForallTripletSpec.Eq = &Eq;
		$$->ForallTripletSpec.Expr = $3;
		$$->ForallTripletSpec.Colon = &Colon;
		$$->ForallTripletSpec.Expr1 = $5;
	}
	| NAME '=' Expr ':' Expr ':' Expr
	{
		$$ = make (FORALL_TRIPLET_SPEC);
		$$->ForallTripletSpec.Name = $1;
		$$->ForallTripletSpec.Eq = &Eq;
		$$->ForallTripletSpec.Expr = $3;
		$$->ForallTripletSpec.Colon = &Colon;
		$$->ForallTripletSpec.Expr1 = $5;
		$$->ForallTripletSpec.Colon1 = &Colon;
		$$->ForallTripletSpec.Expr2 = $7;
	}
	;

IoSpecList
	: IoSpecList ',' IoSpec
	{
		$$ = make (IO_SPEC_LIST);
		$$->IoSpecList.IoSpecList = $1;
		$$->IoSpecList.Comma = &Comma;
		$$->IoSpecList.IoSpec = $3;
	}
	| IoSpec
	{
		$$ = make (IO_SPEC_LIST);
		$$->IoSpecList.IoSpec = $1;
	}
	;

IoSpec
	: NAME '=' Expr
	{
		$$ = make (IO_SPEC);
		$$->IoSpec.Name = $1;
		$$->IoSpec.Eq = &Eq;
		$$->IoSpec.Expr = $3;
	}
	| NAME '=' '*'
	{
		$$ = make (IO_SPEC);
		$$->IoSpec.Name = $1;
		$$->IoSpec.Eq = &Eq;
		$$->IoSpec.Times = &Times;
	}
	| Expr
	{
		$$ = make (IO_SPEC);
		$$->IoSpec.Expr = $1;
	}
	| '*'
	{
		$$ = make (IO_SPEC);
		$$->IoSpec.Times = &Times;
	}
	;

FormatSpec
	: FormatExpr
	| INTEGER_CONSTANT
	| '*'
	{
		$$ = &Times;
	}
	;

InputItemList
	: ImpliedValueList
	;

FormatExpr
	: CHARACTER_CONSTANT
	{
		$$ = $1;
	}

	| Variable
	{
		$$ = $1;
	}

	| FormatExpr CONCAT_OP CHARACTER_CONSTANT
	{
		$$ = make_DumExpr ($1, &ConcatOp, $3);
	}

	| FormatExpr CONCAT_OP Variable
	{
		$$ = make_DumExpr ($1, &ConcatOp, $3);
	}

	;

OutputItemList
	: ImpliedValueList
	;

RenameList
	: RenameList ',' Rename
	{
		$$ = make (RENAME_LIST);
		$$->RenameList.RenameList = $1;
		$$->RenameList.Comma = &Comma;
		$$->RenameList.Rename = $3;
	}
	| Rename
	{
		$$ = make (RENAME_LIST);
		$$->RenameList.Rename = $1;
	}
	;

OnlyList
	: OnlyList ',' Only
	{
		$$ = make (ONLY_LIST);
		$$->OnlyList.OnlyList = $1;
		$$->OnlyList.Comma = &Comma;
		$$->OnlyList.Only = $3;
	}
	| Only
	{
		$$ = make (ONLY_LIST);
		$$->OnlyList.Only = $1;
	}
	;

Rename
	: NAME POINT_OP NAME
	{
		$$ = make (RENAME);
		$$->Rename.Name = $1;
		$$->Rename.PointOp = &PointOp;
		$$->Rename.Name1 = $3;
	}
	;

Only
	: GenericSpec
	| Rename
	;

GenericSpec
	:
	{
		$$ = (Node*) 0;
	}
	| NAME
	{
		$$ = make (GENERIC_SPEC);
		$$->GenericSpec.Name = $1;
	}
	| NAME '(' DefinedOperator ')'
	{
		$$ = make (GENERIC_SPEC);
		$$->GenericSpec.Name = $1;
		$$->GenericSpec.Lp = &Lp;
		$$->GenericSpec.DefinedOperator = $3;
		$$->GenericSpec.Rp = &Rp;
	{
		key_check ($1, "OPERATOR");
	}
	}
	| NAME '(' '=' ')'
	{
		$$ = make (GENERIC_SPEC);
		$$->GenericSpec.Name = $1;
		$$->GenericSpec.Lp = &Lp;
		$$->GenericSpec.Eq = &Eq;
		$$->GenericSpec.Rp = &Rp;
	{
		key_check ($1, "ASSIGNMENT");
	}
	}
	| NAME LPEQI '=' ')'
	{
		$$ = make (GENERIC_SPEC);
		$$->GenericSpec.Name = $1;
		$$->GenericSpec.Lpeqi = &Lpeqi;
		$$->GenericSpec.Eq = &Eq;
		$$->GenericSpec.Rp = &Rp;
	{
		key_check ($1, "ASSIGNMENT");

		$$->GenericSpec.Lpeqi = NN;
		$$->GenericSpec.Lp = &Lp;
	}
	}
	;

opt31
	:
	{
		$$ = (Node*) 0;
	}
	| Prefix
	;

OptNameList
	:
	{
		$$ = (Node*) 0;
	}
	| NameList
	;

opt33
	:
	{
		$$ = (Node*) 0;
	}
	| NAME '(' NAME ')'
	{
		$$ = make (OPT_3_3);
		$$->opt33.Name = $1;
		$$->opt33.Lp = &Lp;
		$$->opt33.Name1 = $3;
		$$->opt33.Rp = &Rp;
	}
	;

Prefix
	: TypeSpec RECURSIVE
	{
		$$ = make (PREFIX);
		$$->Prefix.TypeSpec = $1;
		$$->Prefix.Recursive = &Recursive;
	{
		f90ni_recursive ();
	}
	}
	| TypeSpec
	{
		$$ = make (PREFIX);
		$$->Prefix.TypeSpec = $1;
	}
	| RECURSIVE TypeSpec
	{
		$$ = make (PREFIX);
		$$->Prefix.Recursive = &Recursive;
		$$->Prefix.TypeSpec = $2;
	{
		f90ni_recursive ();
	}
	}
	| RECURSIVE
	{
		$$ = make (PREFIX);
		$$->Prefix.Recursive = &Recursive;
	{
		f90ni_recursive ();
	}
	}
	;

OptRecursive
	:
	{
		$$ = (Node*) 0;
	}
	| RECURSIVE
	{
		f90ni_recursive ();
	}

	;

OptDummyArgList
	:
	{
		$$ = (Node*) 0;
	}
	| DummyArgList
	;

DummyArgList
	: DummyArgList ',' DummyArg
	{
		$$ = make (DUMMY_ARG_LIST);
		$$->DummyArgList.DummyArgList = $1;
		$$->DummyArgList.Comma = &Comma;
		$$->DummyArgList.DummyArg = $3;
	}
	| DummyArg
	{
		$$ = make (DUMMY_ARG_LIST);
		$$->DummyArgList.DummyArg = $1;
	}
	;

DummyArg
	: NAME
	| '*'
	{
		$$ = &Times;
	}
	;
